/*
 *  Author: Mike Atkinson
 *
 *  This software has been developed under the copyleft
 *  rules of the GNU General Public License.  Please
 *  consult the GNU General Public License for more
 *  details about use and distribution of this software.
 */
package net.sourceforge.jrefactory.parser;

import net.sourceforge.jrefactory.ast.*;
import net.sourceforge.jrefactory.io.*;


/* Generated By:JJTree&JavaCC: Do not edit this line. JavaParser.java */
public class JavaParser/*@bgen(jjtree)*/implements JavaParserTreeConstants, JavaParserConstants {/*@bgen(jjtree)*/
  protected JJTJavaParserState jjtree = new JJTJavaParserState();
  private static final boolean TESTING = true;
  private static String target_jdk = "1.5.0";
  private static boolean jdk1_4 = true;
  private static boolean jdk1_5 = true;
  public static boolean generics = true;
  private static boolean annotations = true;
  static boolean useAssert = true;

  public static void setTargetJDK(String target) {
     target_jdk = target;
     jdk1_4 = "1.4.0".compareTo(target_jdk) <= 0;
     jdk1_5 = "1.5.0".compareTo(target_jdk) <= 0;
     generics = "1.5.0".compareTo(target_jdk) <= 0;
     annotations = "1.5.0".compareTo(target_jdk) <= 0;
     useAssert = "1.4.0".compareTo(target_jdk) <= 0;
  }
  static {
      setTargetJDK("1.5.0");
  }

  /** This lookahead is here rather than in the grammar to stop the
   *  generated tree containing an ASTExpressionLookahead class and
   *  the visitor having visit(ASTExpressionLookahead node, Object data);
   */
  private boolean expressionLookahead() {
     Token tok = getToken(1);
     if (tok.kind==COMMA) {
        tok = getToken(2);
        if (!(tok.kind==RPAREN || tok.kind==RBRACE)) {
            return true;
        }
     }
     return false;
  }


  /** This lookahead is here rather than in the grammar to stop the
   *  generated tree containing an ASTForLookahead class and
   *  the visitor having visit(ASTForLookahead node, Object data);
   */
  private boolean forLookahead() {
    int x = 0;
    Token tok = getToken(++x);
    if (tok.kind==FINAL) {
       tok = getToken(++x);
    }
    if (isPrimitiveType(tok)) {
       tok = getToken(++x);
    } else if (tok.kind==IDENTIFIER) {
       tok = getToken(++x);
       while (tok.kind==DOT) {
          tok = getToken(++x);
          if (tok.kind != IDENTIFIER) {
             return false;
          }
          tok = getToken(++x);
       }
    } else {
       return false;
    }
    if (tok.kind==LT) {
       while (true) {
          tok = getToken(++x);
          if (   tok.kind==LT || tok.kind==GT || tok.kind==RSIGNEDSHIFT || tok.kind==RUNSIGNEDSHIFT || tok.kind==DOT
              || tok.kind==COMMA || tok.kind==HOOK || tok.kind==SUPER || tok.kind==EXTENDS || tok.kind==IDENTIFIER) {
             // do nothing
          } else if (tok.kind==LBRACKET) {
             tok = getToken(++x);
             if (tok.kind!=RBRACKET) {
                return false;
             }
          } else {
             break;
          }
       }
       x--;
    } else if (tok.kind==LBRACKET) {
       while (tok.kind==LBRACKET) {
          tok = getToken(++x);
          if (tok.kind!=RBRACKET) {
             return false;
          }
          tok = getToken(++x);
       }
       if (tok.kind != IDENTIFIER) {
          return false;
       }
    }
    tok = getToken(++x);
    return (tok.kind==COLON);
  }


  /** This lookahead is here rather than in the grammar to stop the
   *  generated tree containing an ASTMethodDeclarationLookahead class and
   *  the visitor having visit(ASTMethodDeclarationLookahead node, Object data);
   */
  private boolean methodDeclarationLookahead() {
    int x = 0;
    Token tok = getToken(++x);
    while (    tok.kind==PUBLIC || tok.kind==PROTECTED || tok.kind==PRIVATE
            || tok.kind==STATIC || tok.kind==ABSTRACT || tok.kind==FINAL
            || tok.kind==NATIVE || tok.kind==SYNCHRONIZED || tok.kind==STRICTFP
            || tok.kind==ATTRIBUTE) {
       if (tok.kind==ATTRIBUTE) {
          int count=1;
          tok = getToken(++x);
          if (tok.kind!=IDENTIFIER) {
             return false;
          }
          tok = getToken(++x);
          if (tok.kind != LPAREN) {
             return false;
          }
          while (count>0) {
             tok = getToken(++x);
             if (tok.kind == LPAREN) {
                count++;
             } else if (tok.kind == RPAREN) {
                count--;
             }
          }
       }
       tok = getToken(++x);
    }

    if ( isPrimitiveType(tok) || tok.kind==VOID ) {
       tok = getToken(++x);
    } else if (tok.kind==IDENTIFIER) {
       tok = getToken(++x);
       while (tok.kind==DOT) {
          tok = getToken(++x);
          if (tok.kind != IDENTIFIER) {
             return false;
          }
          tok = getToken(++x);
       }
    } else if (tok.kind==LT) {
       return true;
    } else {
       return false;
    }
    if (tok.kind==LT) {
       while (true) {
          tok = getToken(++x);
          if (   tok.kind==LT || tok.kind==GT || tok.kind==RSIGNEDSHIFT || tok.kind==RUNSIGNEDSHIFT || tok.kind==DOT
              || tok.kind==COMMA || tok.kind==HOOK || tok.kind==SUPER || tok.kind==EXTENDS || tok.kind==IDENTIFIER) {
             // do nothing
          } else if (tok.kind==LBRACKET) {
             tok = getToken(++x);
             if (tok.kind!=RBRACKET) {
                return false;
             }
          } else {
             break;
          }
       }
       x--;
    } else if (tok.kind==LBRACKET) {
       while (tok.kind==LBRACKET) {
          tok = getToken(++x);
          if (tok.kind!=RBRACKET) {
             return false;
          }
          tok = getToken(++x);
       }
       if (tok.kind != IDENTIFIER) {
          return false;
       }
    }
    tok = getToken(++x);
    return (tok.kind==LPAREN);
  }


  /** This lookahead is here rather than in the grammar to stop the
   *  generated tree containing an ASTCastLookahead class and
   *  the visitor having visit(ASTCastLookahead node, Object data);
   */
   private boolean castLookahead() {
      int x = 0;
      Token tok = getToken(++x);
      if (tok.kind!=LPAREN) {
         return false;
      }
      tok = getToken(++x);
      if (tok.kind==IDENTIFIER) {
         tok = getToken(++x);
         while (true) {
            if (tok.kind==LT) {
               x = typeArguments(x);
               if (x<0) {
                  return false;
               }
               tok = getToken(x);  // load next token
            }
            if (tok.kind==LBRACKET) {
               while (tok.kind==LBRACKET) {
                  tok = getToken(++x);
                  if (tok.kind!=RBRACKET) {
                     return false;
                  }
                  tok = getToken(++x);
               }
            }
            if (tok.kind==RPAREN) {
               tok = getToken(++x);
               return castEnd(tok);
            } else if (tok.kind!=DOT) {
               return false;
            }
            tok = getToken(++x);
            if (isPrimitiveType(tok)) {
               tok = getToken(++x);
               if (tok.kind==LBRACKET) {
                  while (tok.kind==LBRACKET) {
                     tok = getToken(++x);
                     if (tok.kind!=RBRACKET) {
                        return false;
                     }
                     tok = getToken(++x);
                  }
               }
               return (tok.kind==RPAREN);
            } else if (tok.kind==IDENTIFIER) {
               tok = getToken(++x);
            }

         }
      } else if (isPrimitiveType(tok)) {
         tok = getToken(++x);
         if (tok.kind==LBRACKET) {
            while (tok.kind==LBRACKET) {
               tok = getToken(++x);
               if (tok.kind!=RBRACKET) {
                  return false;
               }
               tok = getToken(++x);
            }
         }
         return (tok.kind==RPAREN);
      }
      return false;
   }


   private boolean isPrimitiveType(Token tok) {
      return tok.kind==BOOLEAN || tok.kind==CHAR  || tok.kind==BYTE
          || tok.kind==SHORT   || tok.kind==INT   || tok.kind==LONG
          || tok.kind==FLOAT   || tok.kind==DOUBLE;
   }

   private int typeArguments(int x) {
      int level = 1;
      while (true) {
         Token tok = getToken(++x);
         if (tok.kind==GT) {
            --level;
            if (level==0) {
               return x+1;
            } else if (level < 0) {
               return -1; // this is probably a syntax error
            }
         } else if (tok.kind==RSIGNEDSHIFT) {
            level -= 2;
            if (level==0) {
               return x+1;
            } else if (level < 0) {
               return -1; // this is probably a syntax error
            }
         } else if (tok.kind==RUNSIGNEDSHIFT) {
            level -= 2;
            if (level==0) {
               return x+1;
            } else if (level < 0) {
               return -1; // this is probably a syntax error
            }
         } else if (tok.kind==LT) {
            level++;
         }

         if (tok.kind==RPAREN) {
            return -1;
         } else if (tok.kind==DOT) {
         } else if (tok.kind==HOOK || tok.kind==SUPER || tok.kind==EXTENDS || tok.kind==IDENTIFIER) {
            // do nothing
         }
      }
   }


   private boolean castEnd(Token tok) {
      return (   tok.kind==TILDE             || tok.kind==BANG            || tok.kind==LPAREN || tok.kind==IDENTIFIER
              || tok.kind==THIS              || tok.kind==SUPER           || tok.kind==NEW
              || tok.kind==INTEGER_LITERAL   || tok.kind==FLOATING_POINT_LITERAL
              || tok.kind==CHARACTER_LITERAL || tok.kind==STRING_LITERAL
              || tok.kind==TRUE              || tok.kind==FALSE           || tok.kind==NULL );
   }


  public static void main(String args[]) {
  }

/*****************************************
 * THE JAVA LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/

/*
 * Program structuring syntax follows.
 */
  final public ASTCompilationUnit CompilationUnit() throws ParseException {
 /*@bgen(jjtree) CompilationUnit */
    ASTCompilationUnit jjtn000 = new ASTCompilationUnit(this, JJTCOMPILATIONUNIT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PACKAGE:
        PackageDeclaration();
        break;
      default:
        jj_la1[0] = jj_gen;
        ;
      }
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPORT:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_1;
        }
        ImportDeclaration();
      }
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case CLASS:
        case ENUM:
        case FINAL:
        case INTERFACE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case STRICTFP:
        case IDENTIFIER:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[2] = jj_gen;
          break label_2;
        }
        TypeDeclaration();
      }
      tok = jj_consume_token(0);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.addSpecial("EOF", tok.specialToken);
    {if (true) return jjtn000;}
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
    throw new Error("Missing return statement in function");
  }

  final public void PackageDeclaration() throws ParseException {
 /*@bgen(jjtree) PackageDeclaration */
    ASTPackageDeclaration jjtn000 = new ASTPackageDeclaration(this, JJTPACKAGEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(PACKAGE);
                 jjtn000.addSpecial("package", tok.specialToken);
      Name();
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ImportDeclaration() throws ParseException {
 /*@bgen(jjtree) ImportDeclaration */
    ASTImportDeclaration jjtn000 = new ASTImportDeclaration(this, JJTIMPORTDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    Token specialPoint = null;
    int count = 0;
    try {
      specialPoint = jj_consume_token(IMPORT);
                         jjtn000.addSpecial("import", specialPoint.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STATIC:
        specialPoint = jj_consume_token(STATIC);
      jjtn000.addSpecial("static", specialPoint.specialToken);
      jjtn000.setStaticImport(true);
        break;
      default:
        jj_la1[3] = jj_gen;
        ;
      }
      Name();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        specialPoint = jj_consume_token(DOT);
                        jjtn000.addSpecial("period", specialPoint.specialToken);
        tok = jj_consume_token(STAR);
               jjtn000.addSpecial("star", tok.specialToken);
        break;
      default:
        jj_la1[4] = jj_gen;
        ;
      }
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_3;
        }
        specialPoint = jj_consume_token(SEMICOLON);
       count++;
       if (count==1) {
          jjtn000.addSpecial("semicolon", specialPoint.specialToken);
          jjtn000.setImportPackage(tok != null);
       }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void TypeDeclaration() throws ParseException {
 /*@bgen(jjtree) TypeDeclaration */
  ASTTypeDeclaration jjtn000 = new ASTTypeDeclaration(this, JJTTYPEDECLARATION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      if (jj_2_1(2147483647)) {
        AnnotationTypeDeclaration();
      } else if (jj_2_2(2147483647)) {
        ClassDeclaration();
      } else if (jj_2_3(2147483647)) {
        EnumDeclaration();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case INTERFACE:
        case PUBLIC:
        case STRICTFP:
        case ATTRIBUTE:
          InterfaceDeclaration();
          break;
        default:
          jj_la1[6] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

/*
 * Declaration syntax follows.
 */
  final public void ClassDeclaration() throws ParseException {
 /*@bgen(jjtree) ClassDeclaration */
  ASTClassDeclaration jjtn000 = new ASTClassDeclaration(this, JJTCLASSDECLARATION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token tok;
  int count=0;
    try {
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case FINAL:
        case PUBLIC:
        case STRICTFP:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[7] = jj_gen;
          break label_4;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                     jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                     jjtn000.setFinal(); jjtn000.addSpecial("final", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                     jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                     jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      UnmodifiedClassDeclaration();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void UnmodifiedClassDeclaration() throws ParseException {
 /*@bgen(jjtree) UnmodifiedClassDeclaration */
    ASTUnmodifiedClassDeclaration jjtn000 = new ASTUnmodifiedClassDeclaration(this, JJTUNMODIFIEDCLASSDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token specialToken;
    try {
      specialToken = jj_consume_token(CLASS);
                        jjtn000.addSpecial("class", specialToken.specialToken);
      tok = jj_consume_token(IDENTIFIER);
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeParameters();
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
        specialToken = jj_consume_token(EXTENDS);
                             jjtn000.addSpecial("extends", specialToken.specialToken);
        ClassOrInterfaceType();
        break;
      default:
        jj_la1[11] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPLEMENTS:
        specialToken = jj_consume_token(IMPLEMENTS);
                                jjtn000.addSpecial("implements", specialToken.specialToken);
        GenericNameList();
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      ClassBody();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Annotation() throws ParseException {
 /*@bgen(jjtree) Annotation */
  ASTAnnotation jjtn000 = new ASTAnnotation(this, JJTANNOTATION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token specialToken;
  Token tok;
    try {
      Identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        specialToken = jj_consume_token(LPAREN);
                      jjtn000.setMarkerAnnotation(false); jjtn000.addSpecial("begin", specialToken.specialToken);
        if (jj_2_6(1)) {
          if (jj_2_4(2)) {
            MemberValuePairs();
          } else if (jj_2_5(1)) {
            MemberValue();
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else {
          ;
        }
        specialToken = jj_consume_token(RPAREN);
                      jjtn000.addSpecial("end", specialToken.specialToken);
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MemberValuePairs() throws ParseException {
 /*@bgen(jjtree) MemberValuePairs */
  ASTMemberValuePairs jjtn000 = new ASTMemberValuePairs(this, JJTMEMBERVALUEPAIRS);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token specialToken;
  int count=0;
    try {
      MemberValuePair();
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[14] = jj_gen;
          break label_5;
        }
        specialToken = jj_consume_token(COMMA);
                      jjtn000.addSpecial("comma."+count++, specialToken.specialToken);
        MemberValuePair();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MemberValuePair() throws ParseException {
 /*@bgen(jjtree) MemberValuePair */
  ASTMemberValuePair jjtn000 = new ASTMemberValuePair(this, JJTMEMBERVALUEPAIR);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token specialToken;
    try {
      Identifier();
      specialToken = jj_consume_token(ASSIGN);
                    jjtn000.addSpecial("=", specialToken.specialToken);
      MemberValue();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MemberValue() throws ParseException {
 /*@bgen(jjtree) MemberValue */
  ASTMemberValue jjtn000 = new ASTMemberValue(this, JJTMEMBERVALUE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ATTRIBUTE:
        tok = jj_consume_token(ATTRIBUTE);
        Annotation();
                          jjtree.closeNodeScope(jjtn000, true);
                          jjtc000 = false;
                         jjtn000.addSpecial("@", tok.specialToken);
        break;
      case LBRACE:
        MemberValueArrayInitializer();
        break;
      default:
        jj_la1[15] = jj_gen;
        if (jj_2_7(1)) {
          ConditionalExpression();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MemberValueArrayInitializer() throws ParseException {
 /*@bgen(jjtree) MemberValueArrayInitializer */
  ASTMemberValueArrayInitializer jjtn000 = new ASTMemberValueArrayInitializer(this, JJTMEMBERVALUEARRAYINITIALIZER);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token specialToken;
  int count=0;
    try {
      specialToken = jj_consume_token(LBRACE);
                    jjtn000.addSpecial("{", specialToken.specialToken);
      if (jj_2_9(1)) {
        MemberValue();
        label_6:
        while (true) {
          if (jj_2_8(2)) {
            ;
          } else {
            break label_6;
          }
          jj_consume_token(COMMA);
           jjtn000.addSpecial("comma."+count++, specialToken.specialToken);
          MemberValue();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          jj_consume_token(COMMA);
          break;
        default:
          jj_la1[16] = jj_gen;
          ;
        }
      } else {
        ;
      }
      specialToken = jj_consume_token(RBRACE);
                     jjtree.closeNodeScope(jjtn000, true);
                     jjtc000 = false;
                    jjtn000.addSpecial("}", specialToken.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void TypeParameters() throws ParseException {
 /*@bgen(jjtree) TypeParameters */
  ASTTypeParameters jjtn000 = new ASTTypeParameters(this, JJTTYPEPARAMETERS);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token specialToken;
    try {
      specialToken = jj_consume_token(LT);
    if (!jdk1_5) {
      {if (true) throw new ParseException("Type Parameters are only available in JDK 1.5 or later generics" );}
    }
    jjtn000.addSpecial("<", specialToken.specialToken);
      TypeParameterList();
      specialToken = jj_consume_token(GT);
                      jjtree.closeNodeScope(jjtn000, true);
                      jjtc000 = false;
                     jjtn000.addSpecial(">", specialToken.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void TypeParameterList() throws ParseException {
 /*@bgen(jjtree) TypeParameterList */
    ASTTypeParameterList jjtn000 = new ASTTypeParameterList(this, JJTTYPEPARAMETERLIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token generic;
    Token tok;
    int commaCount = 0;
    try {
      TypeParameter();
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[17] = jj_gen;
          break label_7;
        }
        tok = jj_consume_token(COMMA);
               jjtn000.addSpecial("comma."+commaCount, tok.specialToken); commaCount++;
        TypeParameter();
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void TypeParameter() throws ParseException {
 /*@bgen(jjtree) TypeParameter */
    ASTTypeParameter jjtn000 = new ASTTypeParameter(this, JJTTYPEPARAMETER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      Identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
        tok = jj_consume_token(EXTENDS);
                       jjtn000.addSpecial("extends.", tok.specialToken);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ClassOrInterfaceType();
          break;
        default:
          jj_la1[18] = jj_gen;
          ;
        }
        label_8:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BIT_AND:
            ;
            break;
          default:
            jj_la1[19] = jj_gen;
            break label_8;
          }
          tok = jj_consume_token(BIT_AND);
                   jjtn000.addSpecial("and.", tok.specialToken);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ClassOrInterfaceType();
            break;
          default:
            jj_la1[20] = jj_gen;
            ;
          }
        }
        break;
      default:
        jj_la1[21] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void ReferenceTypeList() throws ParseException {
 /*@bgen(jjtree) ReferenceTypeList */
    ASTReferenceTypeList jjtn000 = new ASTReferenceTypeList(this, JJTREFERENCETYPELIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token tok1;
    Token tok2;
    Token tok3;
    int commaCount = 0;
    try {
      tok = jj_consume_token(LT);
    if (!jdk1_5) {
      {if (true) throw new ParseException("Generic reference types are only available in JDK 1.5 or later generics" );}
    }
    jjtn000.addSpecial("<.", tok.specialToken);
      ActualTypeArgument();
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[22] = jj_gen;
          break label_9;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma."+commaCount, tok.specialToken); commaCount++;
        ActualTypeArgument();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GT:
        tok = jj_consume_token(GT);
                jjtree.closeNodeScope(jjtn000, true);
                jjtc000 = false;
      jjtn000.addSpecial(">.", tok.specialToken);
        break;
      case RSIGNEDSHIFT:
        tok = jj_consume_token(RSIGNEDSHIFT);
                 jjtree.closeNodeScope(jjtn000, true);
                 jjtc000 = false;
      jjtn000.addSpecial(">.", tok.specialToken);
      tok2=tok.next;
      tok1=Token.newToken(GT);
      tok.image=">";  tok.kind=GT;  tok.next=tok1;
      tok1.image=">"; tok1.kind=GT; tok1.next=tok2;
        break;
      case RUNSIGNEDSHIFT:
        tok = jj_consume_token(RUNSIGNEDSHIFT);
                  jjtree.closeNodeScope(jjtn000, true);
                  jjtc000 = false;
      jjtn000.addSpecial(">.", tok.specialToken);
      tok3=tok.next;
      tok1=Token.newToken(GT); tok2=Token.newToken(GT);
      tok.image=">";  tok.kind=GT;  tok.next=tok1;
      tok1.image=">"; tok1.kind=GT; tok1.next=tok2;
      tok2.image=">"; tok2.kind=GT; tok2.next=tok3;
        break;
      default:
        jj_la1[23] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ActualTypeArgument() throws ParseException {
 /*@bgen(jjtree) ActualTypeArgument */
    ASTActualTypeArgument jjtn000 = new ASTActualTypeArgument(this, JJTACTUALTYPEARGUMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HOOK:
        // Wildcard
          tok = jj_consume_token(HOOK);
      jjtn000.addSpecial("?", tok.specialToken);
      jjtn000.setWildcard();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EXTENDS:
        case SUPER:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case EXTENDS:
            tok = jj_consume_token(EXTENDS);
                        jjtn000.setExtends(); jjtn000.addSpecial("entends", tok.specialToken);
            break;
          case SUPER:
            tok = jj_consume_token(SUPER);
                      jjtn000.setSuper(); jjtn000.addSpecial("super", tok.specialToken);
            break;
          default:
            jj_la1[24] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          ReferenceType();
          break;
        default:
          jj_la1[25] = jj_gen;
          ;
        }
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case IDENTIFIER:
        ReferenceType();
        break;
      default:
        jj_la1[26] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ClassBody() throws ParseException {
 /*@bgen(jjtree) ClassBody */
    ASTClassBody jjtn000 = new ASTClassBody(this, JJTCLASSBODY);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("begin", tok.specialToken);
      label_10:
      while (true) {
        if (jj_2_10(1)) {
          ;
        } else {
          break label_10;
        }
        ClassBodyDeclaration();
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void NestedClassDeclaration() throws ParseException {
 /*@bgen(jjtree) NestedClassDeclaration */
    ASTNestedClassDeclaration jjtn000 = new ASTNestedClassDeclaration(this, JJTNESTEDCLASSDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count=0;
    try {
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case FINAL:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case STRICTFP:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[27] = jj_gen;
          break label_11;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STATIC:
          tok = jj_consume_token(STATIC);
                      jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                      jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                      jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                      jjtn000.setFinal(); jjtn000.addSpecial("final", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case PROTECTED:
          tok = jj_consume_token(PROTECTED);
                      jjtn000.setProtected(); jjtn000.addSpecial("protected", tok.specialToken);
          break;
        case PRIVATE:
          tok = jj_consume_token(PRIVATE);
                      jjtn000.setPrivate(); jjtn000.addSpecial("private", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                            jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[28] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      UnmodifiedClassDeclaration();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public ASTJSPBody JSPBody() throws ParseException {
 /*@bgen(jjtree) JSPBody */
  ASTJSPBody jjtn000 = new ASTJSPBody(this, JJTJSPBODY);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      label_12:
      while (true) {
        if (jj_2_11(1)) {
          ;
        } else {
          break label_12;
        }
        ClassBodyDeclaration();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    {if (true) return jjtn000;}
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
    throw new Error("Missing return statement in function");
  }

  final public void ClassBodyDeclaration() throws ParseException {
 /*@bgen(jjtree) ClassBodyDeclaration */
  ASTClassBodyDeclaration jjtn000 = new ASTClassBodyDeclaration(this, JJTCLASSBODYDECLARATION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      if (jj_2_12(2147483647)) {
        Initializer();
      } else if (jj_2_13(2147483647)) {
        NestedClassDeclaration();
      } else if (jj_2_14(2147483647)) {
        NestedInterfaceDeclaration();
      } else if (jj_2_15(2147483647)) {
        ConstructorDeclaration();
      } else if (methodDeclarationLookahead()) {
        MethodDeclaration();
      } else if (jj_2_16(2147483647)) {
        EnumDeclaration();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case STRICTFP:
        case TRANSIENT:
        case VOLATILE:
        case IDENTIFIER:
        case ATTRIBUTE:
          FieldDeclaration();
          break;
        default:
          jj_la1[30] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
     if (jjtc000) {
       jjtree.clearNodeScope(jjtn000);
       jjtc000 = false;
     } else {
       jjtree.popNode();
     }
     if (jjte000 instanceof RuntimeException) {
       {if (true) throw (RuntimeException)jjte000;}
     }
     if (jjte000 instanceof ParseException) {
       {if (true) throw (ParseException)jjte000;}
     }
     {if (true) throw (Error)jjte000;}
    } finally {
     if (jjtc000) {
       jjtree.closeNodeScope(jjtn000, true);
     }
    }
  }

// enumeration from jdk1.5
  final public void EnumDeclaration() throws ParseException {
 /*@bgen(jjtree) EnumDeclaration */
    ASTEnumDeclaration jjtn000 = new ASTEnumDeclaration(this, JJTENUMDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token specialToken;
    int elementCount = 0;
    int count = 0;
    try {
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FINAL:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[31] = jj_gen;
          break label_13;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STATIC:
          tok = jj_consume_token(STATIC);
                      jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                      jjtn000.setFinal(); jjtn000.addSpecial("final", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case PROTECTED:
          tok = jj_consume_token(PROTECTED);
                      jjtn000.setProtected(); jjtn000.addSpecial("protected", tok.specialToken);
          break;
        case PRIVATE:
          tok = jj_consume_token(PRIVATE);
                      jjtn000.setPrivate(); jjtn000.addSpecial("private", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[32] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      tok = jj_consume_token(ENUM);
               jjtn000.addSpecial("enum", tok.specialToken);
      Identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPLEMENTS:
        specialToken = jj_consume_token(IMPLEMENTS);
                                jjtn000.addSpecial("implements", specialToken.specialToken);
        GenericNameList();
        break;
      default:
        jj_la1[33] = jj_gen;
        ;
      }
      tok = jj_consume_token(LBRACE);
              jjtn000.addSpecial("begin", tok.specialToken);
      EnumElement();
      label_14:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[34] = jj_gen;
          break label_14;
        }
        tok = jj_consume_token(COMMA);
        EnumElement();
      jjtn000.addSpecial("comma." + elementCount, tok.specialToken);
      elementCount++;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        label_15:
        while (true) {
          if (jj_2_17(1)) {
            ;
          } else {
            break label_15;
          }
          ClassBodyDeclaration();
        }
        break;
      default:
        jj_la1[35] = jj_gen;
        ;
      }
      tok = jj_consume_token(RBRACE);
             jjtn000.addSpecial("end", tok.specialToken);
      label_16:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[36] = jj_gen;
          break label_16;
        }
        jj_consume_token(SEMICOLON);
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Identifier() throws ParseException {
 /*@bgen(jjtree) Identifier */
    ASTIdentifier jjtn000 = new ASTIdentifier(this, JJTIDENTIFIER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(IDENTIFIER);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void EnumElement() throws ParseException {
 /*@bgen(jjtree) EnumElement */
    ASTEnumElement jjtn000 = new ASTEnumElement(this, JJTENUMELEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(IDENTIFIER);
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        Arguments();
        break;
      default:
        jj_la1[37] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        ClassBody();
        break;
      default:
        jj_la1[38] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
    } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
    }
  }

  final public void AnnotationTypeDeclaration() throws ParseException {
 /*@bgen(jjtree) AnnotationTypeDeclaration */
    ASTAnnotationTypeDeclaration jjtn000 = new ASTAnnotationTypeDeclaration(this, JJTANNOTATIONTYPEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count=0;
    try {
      label_17:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case PUBLIC:
        case STRICTFP:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[39] = jj_gen;
          break label_17;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                       jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                       jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                       jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INTERFACE:
            tok = jj_consume_token(INTERFACE);
                             jjtn000.addSpecial("@interface", tok.specialToken);
            break;
          case IDENTIFIER:
            Annotation();
                         jjtn000.addSpecial("@."+count, tok.specialToken); count++;
            break;
          default:
            jj_la1[40] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[41] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      //tok="@" {jjtThis.addSpecial("@", tok.specialToken);}
        //tok="interface"  {jjtThis.addSpecial("interface", tok.specialToken);}
        tok = jj_consume_token(IDENTIFIER);
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("}", tok.specialToken);
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case CLASS:
        case DOUBLE:
        case ENUM:
        case FINAL:
        case FLOAT:
        case INT:
        case INTERFACE:
        case LONG:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case STRICTFP:
        case IDENTIFIER:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[42] = jj_gen;
          break label_18;
        }
        AnnotationTypeMemberDeclaration();
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("}", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AnnotationTypeMemberDeclaration() throws ParseException {
 /*@bgen(jjtree) AnnotationTypeMemberDeclaration */
    ASTAnnotationTypeMemberDeclaration jjtn000 = new ASTAnnotationTypeMemberDeclaration(this, JJTANNOTATIONTYPEMEMBERDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      if (jj_2_18(2147483647)) {
        AnnotationMethodDeclaration();
      } else if (jj_2_19(2147483647)) {
        ConstantDeclaration();
      } else if (jj_2_20(2147483647)) {
        AnnotationTypeDeclaration();
      } else if (jj_2_21(2147483647)) {
        ClassDeclaration();
      } else if (jj_2_22(2147483647)) {
        EnumDeclaration();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case INTERFACE:
        case PUBLIC:
        case STRICTFP:
        case ATTRIBUTE:
          InterfaceDeclaration();
          break;
        default:
          jj_la1[43] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AnnotationMethodDeclaration() throws ParseException {
 /*@bgen(jjtree) AnnotationMethodDeclaration */
    ASTAnnotationMethodDeclaration jjtn000 = new ASTAnnotationMethodDeclaration(this, JJTANNOTATIONMETHODDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      label_19:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case PUBLIC:
          ;
          break;
        default:
          jj_la1[44] = jj_gen;
          break label_19;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                         jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                         jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        default:
          jj_la1[45] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      Type();
      Identifier();
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("(", tok.specialToken);
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial(")", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _DEFAULT:
        tok = jj_consume_token(_DEFAULT);
                   jjtn000.addSpecial("detault", tok.specialToken);
        MemberValue();
        break;
      default:
        jj_la1[46] = jj_gen;
        ;
      }
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ConstantDeclaration() throws ParseException {
 /*@bgen(jjtree) ConstantDeclaration */
    ASTConstantDeclaration jjtn000 = new ASTConstantDeclaration(this, JJTCONSTANTDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
        break;
      case STATIC:
        tok = jj_consume_token(STATIC);
                      jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
        break;
      case FINAL:
        tok = jj_consume_token(FINAL);
                      jjtn000.setFinal();  jjtn000.addSpecial("final", tok.specialToken);
        break;
      default:
        jj_la1[47] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Type();
      VariableDeclarator();
      label_20:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[48] = jj_gen;
          break label_20;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
        VariableDeclarator();
      }
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void InterfaceDeclaration() throws ParseException {
 /*@bgen(jjtree) InterfaceDeclaration */
    ASTInterfaceDeclaration jjtn000 = new ASTInterfaceDeclaration(this, JJTINTERFACEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count=0;
    try {
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case PUBLIC:
        case STRICTFP:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[49] = jj_gen;
          break label_21;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                      jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                      jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[50] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      UnmodifiedInterfaceDeclaration();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[51] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void NestedInterfaceDeclaration() throws ParseException {
 /*@bgen(jjtree) NestedInterfaceDeclaration */
    ASTNestedInterfaceDeclaration jjtn000 = new ASTNestedInterfaceDeclaration(this, JJTNESTEDINTERFACEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count=0;
    try {
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case FINAL:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case STRICTFP:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_22;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STATIC:
          tok = jj_consume_token(STATIC);
                      jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
          break;
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                      jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                      jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                      jjtn000.setFinal(); jjtn000.addSpecial("final", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case PROTECTED:
          tok = jj_consume_token(PROTECTED);
                      jjtn000.setProtected(); jjtn000.addSpecial("protected", tok.specialToken);
          break;
        case PRIVATE:
          tok = jj_consume_token(PRIVATE);
                      jjtn000.setPrivate(); jjtn000.addSpecial("private", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[53] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      UnmodifiedInterfaceDeclaration();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[54] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void UnmodifiedInterfaceDeclaration() throws ParseException {
 /*@bgen(jjtree) UnmodifiedInterfaceDeclaration */
    ASTUnmodifiedInterfaceDeclaration jjtn000 = new ASTUnmodifiedInterfaceDeclaration(this, JJTUNMODIFIEDINTERFACEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token specialToken;
    Token tok;
    try {
      specialToken = jj_consume_token(INTERFACE);
                            jjtn000.addSpecial("interface", specialToken.specialToken);
      tok = jj_consume_token(IDENTIFIER);
    jjtn000.setName(tok.image);
    {jjtn000.addSpecial("id", tok.specialToken);}
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeParameters();
        break;
      default:
        jj_la1[55] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
        specialToken = jj_consume_token(EXTENDS);
                            jjtn000.addSpecial("extends", specialToken.specialToken);
        GenericNameList();
        break;
      default:
        jj_la1[56] = jj_gen;
        ;
      }
      InterfaceBody();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void InterfaceBody() throws ParseException {
 /*@bgen(jjtree) InterfaceBody */
        ASTInterfaceBody jjtn000 = new ASTInterfaceBody(this, JJTINTERFACEBODY);
        boolean jjtc000 = true;
        jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("begin", tok.specialToken);
      label_23:
      while (true) {
        if (jj_2_23(1)) {
          ;
        } else {
          break label_23;
        }
        InterfaceMemberDeclaration();
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void InterfaceMemberDeclaration() throws ParseException {
 /*@bgen(jjtree) InterfaceMemberDeclaration */
  ASTInterfaceMemberDeclaration jjtn000 = new ASTInterfaceMemberDeclaration(this, JJTINTERFACEMEMBERDECLARATION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      if (jj_2_24(2147483647)) {
        NestedClassDeclaration();
      } else if (jj_2_25(2147483647)) {
        NestedInterfaceDeclaration();
      } else if (methodDeclarationLookahead()) {
        MethodDeclaration();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case SHORT:
        case STATIC:
        case STRICTFP:
        case TRANSIENT:
        case VOLATILE:
        case IDENTIFIER:
        case ATTRIBUTE:
          FieldDeclaration();
          break;
        default:
          jj_la1[57] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void FieldDeclaration() throws ParseException {
 /*@bgen(jjtree) FieldDeclaration */
    ASTFieldDeclaration jjtn000 = new ASTFieldDeclaration(this, JJTFIELDDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    int count = 0;
    try {
      label_24:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FINAL:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case STRICTFP:
        case TRANSIENT:
        case VOLATILE:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[58] = jj_gen;
          break label_24;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STATIC:
          tok = jj_consume_token(STATIC);
                      jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
          break;
        case TRANSIENT:
          tok = jj_consume_token(TRANSIENT);
                      jjtn000.addModifier(tok.image); jjtn000.addSpecial("transient", tok.specialToken);
          break;
        case VOLATILE:
          tok = jj_consume_token(VOLATILE);
                      jjtn000.addModifier(tok.image); jjtn000.addSpecial("volatile", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                      jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                      jjtn000.setFinal();  jjtn000.addSpecial("final", tok.specialToken);
          break;
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                      jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case PROTECTED:
          tok = jj_consume_token(PROTECTED);
                      jjtn000.setProtected(); jjtn000.addSpecial("protected", tok.specialToken);
          break;
        case PRIVATE:
          tok = jj_consume_token(PRIVATE);
                      jjtn000.setPrivate(); jjtn000.addSpecial("private", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.setPrivate(); jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[59] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      Type();
      VariableDeclarator();
      label_25:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[60] = jj_gen;
          break label_25;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
        VariableDeclarator();
      }
      tok = jj_consume_token(SEMICOLON);
           jjtn000.addSpecial("semicolon", tok.specialToken);
      label_26:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[61] = jj_gen;
          break label_26;
        }
        jj_consume_token(SEMICOLON);
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void VariableDeclarator() throws ParseException {
 /*@bgen(jjtree) VariableDeclarator */
    ASTVariableDeclarator jjtn000 = new ASTVariableDeclarator(this, JJTVARIABLEDECLARATOR);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      VariableDeclaratorId();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        tok = jj_consume_token(ASSIGN);
             jjtn000.addSpecial("equals", tok.specialToken);
        VariableInitializer();
        break;
      default:
        jj_la1[62] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void VariableDeclaratorId() throws ParseException {
 /*@bgen(jjtree) VariableDeclaratorId */
    ASTVariableDeclaratorId jjtn000 = new ASTVariableDeclaratorId(this, JJTVARIABLEDECLARATORID);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int arrayCount = 0;
    try {
      tok = jj_consume_token(IDENTIFIER);
    jjtn000.addSpecial("id", tok.specialToken);
    jjtn000.setName(tok.image);
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          ;
          break;
        default:
          jj_la1[63] = jj_gen;
          break label_27;
        }
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
     arrayCount++;
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setArrayCount(arrayCount);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void VariableInitializer() throws ParseException {
 /*@bgen(jjtree) VariableInitializer */
  ASTVariableInitializer jjtn000 = new ASTVariableInitializer(this, JJTVARIABLEINITIALIZER);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        ArrayInitializer();
        break;
      default:
        jj_la1[64] = jj_gen;
        if (jj_2_26(1)) {
          Expression();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ArrayInitializer() throws ParseException {
 /*@bgen(jjtree) ArrayInitializer */
    ASTArrayInitializer jjtn000 = new ASTArrayInitializer(this, JJTARRAYINITIALIZER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      tok = jj_consume_token(LBRACE);
            jjtn000.addSpecial("begin", tok.specialToken);
      if (jj_2_28(1)) {
        VariableInitializer();
        label_28:
        while (true) {
          if (jj_2_27(2)) {
            ;
          } else {
            break label_28;
          }
          tok = jj_consume_token(COMMA);
               jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
          VariableInitializer();
        }
      } else {
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        tok = jj_consume_token(COMMA);
      jjtn000.addSpecial("comma." + commaCount, tok.specialToken);
      commaCount++;
      jjtn000.setFinalComma(true);
        break;
      default:
        jj_la1[65] = jj_gen;
        ;
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
            jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MethodDeclaration() throws ParseException {
 /*@bgen(jjtree) MethodDeclaration */
    ASTMethodDeclaration jjtn000 = new ASTMethodDeclaration(this, JJTMETHODDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count=0;
    try {
      label_29:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ABSTRACT:
        case FINAL:
        case NATIVE:
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case STATIC:
        case STRICTFP:
        case SYNCHRONIZED:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[66] = jj_gen;
          break label_29;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PUBLIC:
          tok = jj_consume_token(PUBLIC);
                         jjtn000.setPublic(); jjtn000.addSpecial("public", tok.specialToken);
          break;
        case PROTECTED:
          tok = jj_consume_token(PROTECTED);
                         jjtn000.setProtected(); jjtn000.addSpecial("protected", tok.specialToken);
          break;
        case PRIVATE:
          tok = jj_consume_token(PRIVATE);
                         jjtn000.setPrivate(); jjtn000.addSpecial("private", tok.specialToken);
          break;
        case STATIC:
          tok = jj_consume_token(STATIC);
                         jjtn000.setStatic(); jjtn000.addSpecial("static", tok.specialToken);
          break;
        case ABSTRACT:
          tok = jj_consume_token(ABSTRACT);
                         jjtn000.setAbstract(); jjtn000.addSpecial("abstract", tok.specialToken);
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                         jjtn000.setFinal(); jjtn000.addSpecial("final", tok.specialToken);
          break;
        case NATIVE:
          tok = jj_consume_token(NATIVE);
                         jjtn000.addModifier(tok.image); jjtn000.addSpecial("native", tok.specialToken);
          break;
        case STRICTFP:
          tok = jj_consume_token(STRICTFP);
                         jjtn000.setStrict(); jjtn000.addSpecial("strictfp", tok.specialToken);
          break;
        case SYNCHRONIZED:
          tok = jj_consume_token(SYNCHRONIZED);
                         jjtn000.setSynchronized(); jjtn000.addSpecial("synchronized", tok.specialToken);
          break;
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        default:
          jj_la1[67] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeParameters();
        break;
      default:
        jj_la1[68] = jj_gen;
        ;
      }
      ResultType();
      MethodDeclarator();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case THROWS:
        tok = jj_consume_token(THROWS);
                  jjtn000.addSpecial("throws", tok.specialToken);
        NameList();
        break;
      default:
        jj_la1[69] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        Block();
        break;
      case SEMICOLON:
        tok = jj_consume_token(SEMICOLON);
               jjtn000.addSpecial("semicolon", tok.specialToken);
        break;
      default:
        jj_la1[70] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      label_30:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[71] = jj_gen;
          break label_30;
        }
        jj_consume_token(SEMICOLON);
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MethodDeclarator() throws ParseException {
 /*@bgen(jjtree) MethodDeclarator */
    ASTMethodDeclarator jjtn000 = new ASTMethodDeclarator(this, JJTMETHODDECLARATOR);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int arrayCount = 0;
    try {
      tok = jj_consume_token(IDENTIFIER);
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("id", tok.specialToken);
      FormalParameters();
      label_31:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          ;
          break;
        default:
          jj_la1[72] = jj_gen;
          break label_31;
        }
        tok = jj_consume_token(LBRACKET);
               jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
        tok = jj_consume_token(RBRACKET);
               jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
       arrayCount++;
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setArrayCount(arrayCount);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void FormalParameters() throws ParseException {
 /*@bgen(jjtree) FormalParameters */
    ASTFormalParameters jjtn000 = new ASTFormalParameters(this, JJTFORMALPARAMETERS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("begin", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FINAL:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case IDENTIFIER:
      case ATTRIBUTE:
        FormalParameter();
        label_32:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[73] = jj_gen;
            break label_32;
          }
          tok = jj_consume_token(COMMA);
               jjtn000.addSpecial("comma." + commaCount, tok.specialToken);
          FormalParameter();
       commaCount++;
        }
        break;
      default:
        jj_la1[74] = jj_gen;
        ;
      }
      tok = jj_consume_token(RPAREN);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void FormalParameter() throws ParseException {
 /*@bgen(jjtree) FormalParameter */
    ASTFormalParameter jjtn000 = new ASTFormalParameter(this, JJTFORMALPARAMETER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    int count=0;
    try {
      label_33:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FINAL:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[75] = jj_gen;
          break label_33;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                            jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                  jjtn000.setUsingFinal(true); jjtn000.addSpecial("final", tok.specialToken);
          break;
        default:
          jj_la1[76] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      Type();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VARARG:
        tok = jj_consume_token(VARARG);
               jjtn000.setVarArg(true); jjtn000.addSpecial("vararg", tok.specialToken);
        break;
      default:
        jj_la1[77] = jj_gen;
        ;
      }
      VariableDeclaratorId();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ConstructorDeclaration() throws ParseException {
 /*@bgen(jjtree) ConstructorDeclaration */
    ASTConstructorDeclaration jjtn000 = new ASTConstructorDeclaration(this, JJTCONSTRUCTORDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token mod;
    int count = 0;
    try {
      label_34:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PRIVATE:
        case PROTECTED:
        case PUBLIC:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[78] = jj_gen;
          break label_34;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTRIBUTE:
          mod = jj_consume_token(ATTRIBUTE);
          Annotation();
                           jjtn000.addSpecial("@."+count, mod.specialToken); count++;
          break;
        case PUBLIC:
          mod = jj_consume_token(PUBLIC);
                           jjtn000.setPublic(); jjtn000.addSpecial("public", mod.specialToken);
          break;
        case PROTECTED:
          mod = jj_consume_token(PROTECTED);
                           jjtn000.setProtected(); jjtn000.addSpecial("protected", mod.specialToken);
          break;
        case PRIVATE:
          mod = jj_consume_token(PRIVATE);
                           jjtn000.setPrivate(); jjtn000.addSpecial("private", mod.specialToken);
          break;
        default:
          jj_la1[79] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeParameters();
        break;
      default:
        jj_la1[80] = jj_gen;
        ;
      }
      tok = jj_consume_token(IDENTIFIER);
    jjtn000.addSpecial("id", tok.specialToken);
    jjtn000.setName(tok.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeArguments();
        break;
      default:
        jj_la1[81] = jj_gen;
        ;
      }
      FormalParameters();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case THROWS:
        tok = jj_consume_token(THROWS);
                  jjtn000.addSpecial("throws", tok.specialToken);
        NameList();
        break;
      default:
        jj_la1[82] = jj_gen;
        ;
      }
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("begin", tok.specialToken);
      if (jj_2_29(2147483647)) {
        ExplicitConstructorInvocation();
      } else {
        ;
      }
      label_35:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CLASS:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case INTERFACE:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case SEMICOLON:
        case INCR:
        case DECR:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[83] = jj_gen;
          break label_35;
        }
        BlockStatement();
      }
      tok = jj_consume_token(RBRACE);
           jjtn000.addSpecial("end", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[84] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ExplicitConstructorInvocation() throws ParseException {
 /*@bgen(jjtree) ExplicitConstructorInvocation */
    ASTExplicitConstructorInvocation jjtn000 = new ASTExplicitConstructorInvocation(this, JJTEXPLICITCONSTRUCTORINVOCATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token semicolon;
    Token dot = null;
    try {
      if (jj_2_31(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          TypeArguments();
          break;
        default:
          jj_la1[85] = jj_gen;
          ;
        }
        // new
          tok = jj_consume_token(THIS);
        Arguments();
        semicolon = jj_consume_token(SEMICOLON);
                                        ((ASTExplicitConstructorInvocation)jjtn000).setIsThis();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case LT:
          if (jj_2_30(2147483647)) {
            PrimaryExpression();
            dot = jj_consume_token(DOT);
                                                                      jjtn000.addSpecial(".", dot.specialToken);
          } else {
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            Identifier();
            dot = jj_consume_token(DOT);
                           jjtn000.addSpecial(".2", dot.specialToken);
            break;
          default:
            jj_la1[86] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LT:
            TypeArguments();
            break;
          default:
            jj_la1[87] = jj_gen;
            ;
          }
          tok = jj_consume_token(SUPER);
          Arguments();
          semicolon = jj_consume_token(SEMICOLON);
    ((ASTExplicitConstructorInvocation)jjtn000).setIsSuper();
          break;
        default:
          jj_la1[88] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("explicit", tok.specialToken);
    jjtn000.addSpecial("semicolon", semicolon.specialToken);
    } catch (Throwable jjte000) {
  if (jjtc000) {
    jjtree.clearNodeScope(jjtn000);
    jjtc000 = false;
  } else {
    jjtree.popNode();
  }
  if (jjte000 instanceof RuntimeException) {
    {if (true) throw (RuntimeException)jjte000;}
  }
  if (jjte000 instanceof ParseException) {
    {if (true) throw (ParseException)jjte000;}
  }
  {if (true) throw (Error)jjte000;}
    } finally {
  if (jjtc000) {
    jjtree.closeNodeScope(jjtn000, true);
  }
    }
  }

  final public void Initializer() throws ParseException {
 /*@bgen(jjtree) Initializer */
    ASTInitializer jjtn000 = new ASTInitializer(this, JJTINITIALIZER);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STATIC:
        tok = jj_consume_token(STATIC);
        break;
      default:
        jj_la1[89] = jj_gen;
        ;
      }
      Block();
    jjtn000.setUsingStatic(tok != null);
    if (tok != null) {
      jjtn000.addSpecial("static", tok.specialToken);
    }
      label_36:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[90] = jj_gen;
          break label_36;
        }
        jj_consume_token(SEMICOLON);
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

/*
 * Type, name and expression syntax follows.
 */
  final public void Type() throws ParseException {
 /*@bgen(jjtree) Type */
  ASTType jjtn000 = new ASTType(this, JJTTYPE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      if (jj_2_32(2)) {
        ReferenceType();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FLOAT:
        case INT:
        case LONG:
        case SHORT:
          PrimitiveType();
          break;
        default:
          jj_la1[91] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ReferenceType() throws ParseException {
 /*@bgen(jjtree) ReferenceType */
    ASTReferenceType jjtn000 = new ASTReferenceType(this, JJTREFERENCETYPE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);int arrayCount = 0;
    Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ClassOrInterfaceType();
        label_37:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            ;
            break;
          default:
            jj_la1[92] = jj_gen;
            break label_37;
          }
          tok = jj_consume_token(LBRACKET);
                 jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
          tok = jj_consume_token(RBRACKET);
                 jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
         arrayCount++;
        }
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
        PrimitiveType();
        label_38:
        while (true) {
          tok = jj_consume_token(LBRACKET);
                 jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
          tok = jj_consume_token(RBRACKET);
                 jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
         arrayCount++;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            ;
            break;
          default:
            jj_la1[93] = jj_gen;
            break label_38;
          }
        }
        break;
      default:
        jj_la1[94] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setArrayCount(arrayCount);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void TypeArguments() throws ParseException {
 /*@bgen(jjtree) TypeArguments */
    ASTTypeArguments jjtn000 = new ASTTypeArguments(this, JJTTYPEARGUMENTS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token tok1;
    Token tok2;
    Token tok3;
    int commaCount = 0;
    try {
      tok = jj_consume_token(LT);
    if (!jdk1_5) {
      {if (true) throw new ParseException("Generic type arguments are only available in JDK 1.5 or later generics" );}
    }
    jjtn000.addSpecial("<.", tok.specialToken);
      ActualTypeArgument();
      label_39:
      while (true) {
        if (jj_2_33(2)) {
          ;
        } else {
          break label_39;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
        ActualTypeArgument();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GT:
        tok = jj_consume_token(GT);
               jjtree.closeNodeScope(jjtn000, true);
               jjtc000 = false;
              jjtn000.addSpecial(">.", tok.specialToken);
        break;
      case RSIGNEDSHIFT:
        tok = jj_consume_token(RSIGNEDSHIFT);
                 jjtree.closeNodeScope(jjtn000, true);
                 jjtc000 = false;
        jjtn000.addSpecial(">.", tok.specialToken);
        tok2=tok.next;
        tok1=Token.newToken(GT);
        tok.image=">";  tok.kind=GT;  tok.next=tok1;
        tok1.image=">"; tok1.kind=GT; tok1.next=tok2;
        break;
      case RUNSIGNEDSHIFT:
        tok = jj_consume_token(RUNSIGNEDSHIFT);
                  jjtree.closeNodeScope(jjtn000, true);
                  jjtc000 = false;
        jjtn000.addSpecial(">.", tok.specialToken);
        tok3=tok.next;
        tok1=Token.newToken(GT); tok2=Token.newToken(GT);
        tok.image=">";  tok.kind=GT;  tok.next=tok1;
        tok1.image=">"; tok1.kind=GT; tok1.next=tok2;
        tok2.image=">"; tok2.kind=GT; tok2.next=tok3;
        break;
      default:
        jj_la1[95] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PrimitiveType() throws ParseException {
 /*@bgen(jjtree) PrimitiveType */
    ASTPrimitiveType jjtn000 = new ASTPrimitiveType(this, JJTPRIMITIVETYPE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BOOLEAN:
        tok = jj_consume_token(BOOLEAN);
        break;
      case CHAR:
        tok = jj_consume_token(CHAR);
        break;
      case BYTE:
        tok = jj_consume_token(BYTE);
        break;
      case SHORT:
        tok = jj_consume_token(SHORT);
        break;
      case INT:
        tok = jj_consume_token(INT);
        break;
      case LONG:
        tok = jj_consume_token(LONG);
        break;
      case FLOAT:
        tok = jj_consume_token(FLOAT);
        break;
      case DOUBLE:
        tok = jj_consume_token(DOUBLE);
        break;
      default:
        jj_la1[96] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("primitive", tok.specialToken);
    } finally {
  if (jjtc000) {
    jjtree.closeNodeScope(jjtn000, true);
  }
    }
  }

  final public void ResultType() throws ParseException {
 /*@bgen(jjtree) ResultType */
    ASTResultType jjtn000 = new ASTResultType(this, JJTRESULTTYPE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VOID:
        tok = jj_consume_token(VOID);
                jjtree.closeNodeScope(jjtn000, true);
                jjtc000 = false;
               jjtn000.addSpecial("primitive", tok.specialToken);
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FLOAT:
      case INT:
      case LONG:
      case SHORT:
      case IDENTIFIER:
        Type();
        break;
      default:
        jj_la1[97] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Name() throws ParseException {
 /*@bgen(jjtree) Name */
    ASTName jjtn000 = new ASTName(this, JJTNAME);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token period;
    int count = 0;
    try {
      tok = jj_consume_token(IDENTIFIER);
                    jjtn000.addSpecial("id" + count, tok.specialToken);
    if (TESTING) {
        jjtn000.testingOnly__setBeginLine( tok.beginLine);
        jjtn000.testingOnly__setBeginColumn( tok.beginColumn);
    }
    jjtn000.addNamePart(tok.image);
    count++;
      label_40:
      while (true) {
        if (jj_2_34(2)) {
          ;
        } else {
          break label_40;
        }
        period = jj_consume_token(DOT);
        tok = jj_consume_token(IDENTIFIER);
      jjtn000.addNamePart(tok.image);
      jjtn000.addSpecial("period" + count, period.specialToken);
      jjtn000.addSpecial("id" + count, tok.specialToken);
      count++;
      }
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ClassOrInterfaceType() throws ParseException {
 /*@bgen(jjtree) ClassOrInterfaceType */
    ASTClassOrInterfaceType jjtn000 = new ASTClassOrInterfaceType(this, JJTCLASSORINTERFACETYPE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token period;
    int count = 0;
    try {
      Identifier();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        TypeArguments();
        break;
      default:
        jj_la1[98] = jj_gen;
        ;
      }
      label_41:
      while (true) {
        if (jj_2_35(2147483647)) {
          ;
        } else {
          break label_41;
        }
        period = jj_consume_token(DOT);
        Identifier();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          TypeArguments();
          break;
        default:
          jj_la1[99] = jj_gen;
          ;
        }
      jjtn000.addSpecial("period." + count, period.specialToken);
      count++;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void NameList() throws ParseException {
 /*@bgen(jjtree) NameList */
    ASTNameList jjtn000 = new ASTNameList(this, JJTNAMELIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      Name();
      label_42:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[100] = jj_gen;
          break label_42;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken);
        Name();
     commaCount++;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void GenericNameList() throws ParseException {
 /*@bgen(jjtree) GenericNameList */
    ASTGenericNameList jjtn000 = new ASTGenericNameList(this, JJTGENERICNAMELIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      ClassOrInterfaceType();
      label_43:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[101] = jj_gen;
          break label_43;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken);
        ClassOrInterfaceType();
     commaCount++;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

/*
 * Expression syntax follows.
 */
  final public void Expression() throws ParseException {
 /*@bgen(jjtree) Expression */
  ASTExpression jjtn000 = new ASTExpression(this, JJTEXPRESSION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      ConditionalExpression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
      case PLUSASSIGN:
      case MINUSASSIGN:
      case STARASSIGN:
      case SLASHASSIGN:
      case ANDASSIGN:
      case ORASSIGN:
      case XORASSIGN:
      case REMASSIGN:
      case LSHIFTASSIGN:
      case RSIGNEDSHIFTASSIGN:
      case RUNSIGNEDSHIFTASSIGN:
        AssignmentOperator();
        Expression();
        break;
      default:
        jj_la1[102] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AssignmentOperator() throws ParseException {
 /*@bgen(jjtree) AssignmentOperator */
    ASTAssignmentOperator jjtn000 = new ASTAssignmentOperator(this, JJTASSIGNMENTOPERATOR);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        tok = jj_consume_token(ASSIGN);
        break;
      case STARASSIGN:
        tok = jj_consume_token(STARASSIGN);
        break;
      case SLASHASSIGN:
        tok = jj_consume_token(SLASHASSIGN);
        break;
      case REMASSIGN:
        tok = jj_consume_token(REMASSIGN);
        break;
      case PLUSASSIGN:
        tok = jj_consume_token(PLUSASSIGN);
        break;
      case MINUSASSIGN:
        tok = jj_consume_token(MINUSASSIGN);
        break;
      case LSHIFTASSIGN:
        tok = jj_consume_token(LSHIFTASSIGN);
        break;
      case RSIGNEDSHIFTASSIGN:
        tok = jj_consume_token(RSIGNEDSHIFTASSIGN);
        break;
      case RUNSIGNEDSHIFTASSIGN:
        tok = jj_consume_token(RUNSIGNEDSHIFTASSIGN);
        break;
      case ANDASSIGN:
        tok = jj_consume_token(ANDASSIGN);
        break;
      case XORASSIGN:
        tok = jj_consume_token(XORASSIGN);
        break;
      case ORASSIGN:
        tok = jj_consume_token(ORASSIGN);
        break;
      default:
        jj_la1[103] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("operator", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ConditionalExpression() throws ParseException {
 /*@bgen(jjtree) ConditionalExpression */
    ASTConditionalExpression jjtn000 = new ASTConditionalExpression(this, JJTCONDITIONALEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      ConditionalOrExpression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HOOK:
        tok = jj_consume_token(HOOK);
             jjtn000.addSpecial("?", tok.specialToken);
        Expression();
        tok = jj_consume_token(COLON);
             jjtn000.addSpecial(":", tok.specialToken);
        ConditionalExpression();
        break;
      default:
        jj_la1[104] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ConditionalOrExpression() throws ParseException {
 /*@bgen(jjtree) ConditionalOrExpression */
    ASTConditionalOrExpression jjtn000 = new ASTConditionalOrExpression(this, JJTCONDITIONALOREXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      ConditionalAndExpression();
      label_44:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SC_OR:
          ;
          break;
        default:
          jj_la1[105] = jj_gen;
          break label_44;
        }
        tok = jj_consume_token(SC_OR);
              jjtn000.addSpecial("operator." + count, tok.specialToken); count++;
        ConditionalAndExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ConditionalAndExpression() throws ParseException {
 /*@bgen(jjtree) ConditionalAndExpression */
    ASTConditionalAndExpression jjtn000 = new ASTConditionalAndExpression(this, JJTCONDITIONALANDEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      InclusiveOrExpression();
      label_45:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SC_AND:
          ;
          break;
        default:
          jj_la1[106] = jj_gen;
          break label_45;
        }
        tok = jj_consume_token(SC_AND);
              jjtn000.addSpecial("operator." + count, tok.specialToken); count++;
        InclusiveOrExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void InclusiveOrExpression() throws ParseException {
 /*@bgen(jjtree) InclusiveOrExpression */
    ASTInclusiveOrExpression jjtn000 = new ASTInclusiveOrExpression(this, JJTINCLUSIVEOREXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      ExclusiveOrExpression();
      label_46:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BIT_OR:
          ;
          break;
        default:
          jj_la1[107] = jj_gen;
          break label_46;
        }
        tok = jj_consume_token(BIT_OR);
             jjtn000.addSpecial("operator." + count, tok.specialToken); count++;
        ExclusiveOrExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ExclusiveOrExpression() throws ParseException {
 /*@bgen(jjtree) ExclusiveOrExpression */
    ASTExclusiveOrExpression jjtn000 = new ASTExclusiveOrExpression(this, JJTEXCLUSIVEOREXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      AndExpression();
      label_47:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case XOR:
          ;
          break;
        default:
          jj_la1[108] = jj_gen;
          break label_47;
        }
        tok = jj_consume_token(XOR);
             jjtn000.addSpecial("operator." + count, tok.specialToken); count++;
        AndExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AndExpression() throws ParseException {
 /*@bgen(jjtree) AndExpression */
    ASTAndExpression jjtn000 = new ASTAndExpression(this, JJTANDEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      EqualityExpression();
      label_48:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BIT_AND:
          ;
          break;
        default:
          jj_la1[109] = jj_gen;
          break label_48;
        }
        tok = jj_consume_token(BIT_AND);
             jjtn000.addSpecial("operator." + count, tok.specialToken); count++;
        EqualityExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void EqualityExpression() throws ParseException {
 /*@bgen(jjtree) EqualityExpression */
    ASTEqualityExpression jjtn000 = new ASTEqualityExpression(this, JJTEQUALITYEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      InstanceOfExpression();
      label_49:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EQ:
        case NE:
          ;
          break;
        default:
          jj_la1[110] = jj_gen;
          break label_49;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EQ:
          tok = jj_consume_token(EQ);
          break;
        case NE:
          tok = jj_consume_token(NE);
          break;
        default:
          jj_la1[111] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        InstanceOfExpression();
        jjtn000.addName(tok.image);
        jjtn000.addSpecial("operator." + count, tok.specialToken);
        count++;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void InstanceOfExpression() throws ParseException {
 /*@bgen(jjtree) InstanceOfExpression */
    ASTInstanceOfExpression jjtn000 = new ASTInstanceOfExpression(this, JJTINSTANCEOFEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      RelationalExpression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INSTANCEOF:
        tok = jj_consume_token(INSTANCEOF);
        ReferenceType();
     jjtn000.addSpecial("operator.0", tok.specialToken);
        break;
      default:
        jj_la1[112] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void RelationalExpression() throws ParseException {
 /*@bgen(jjtree) RelationalExpression */
    ASTRelationalExpression jjtn000 = new ASTRelationalExpression(this, JJTRELATIONALEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      ShiftExpression();
      label_50:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case GT:
        case LT:
        case LE:
        case GE:
          ;
          break;
        default:
          jj_la1[113] = jj_gen;
          break label_50;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          tok = jj_consume_token(LT);
          break;
        case GT:
          tok = jj_consume_token(GT);
          break;
        case LE:
          tok = jj_consume_token(LE);
          break;
        case GE:
          tok = jj_consume_token(GE);
          break;
        default:
          jj_la1[114] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      jjtn000.addName(tok.image);
      jjtn000.addSpecial("operator." + count, tok.specialToken);
      count++;
        ShiftExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ShiftExpression() throws ParseException {
 /*@bgen(jjtree) ShiftExpression */
    ASTShiftExpression jjtn000 = new ASTShiftExpression(this, JJTSHIFTEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      AdditiveExpression();
      label_51:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LSHIFT:
        case RSIGNEDSHIFT:
        case RUNSIGNEDSHIFT:
          ;
          break;
        default:
          jj_la1[115] = jj_gen;
          break label_51;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LSHIFT:
          tok = jj_consume_token(LSHIFT);
          break;
        case RSIGNEDSHIFT:
          tok = jj_consume_token(RSIGNEDSHIFT);
          break;
        case RUNSIGNEDSHIFT:
          tok = jj_consume_token(RUNSIGNEDSHIFT);
          break;
        default:
          jj_la1[116] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jjtn000.addName(tok.image);
        jjtn000.addSpecial("operator." + count, tok.specialToken);
        count++;
        AdditiveExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AdditiveExpression() throws ParseException {
 /*@bgen(jjtree) AdditiveExpression */
    ASTAdditiveExpression jjtn000 = new ASTAdditiveExpression(this, JJTADDITIVEEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      MultiplicativeExpression();
      label_52:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
        case MINUS:
          ;
          break;
        default:
          jj_la1[117] = jj_gen;
          break label_52;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          tok = jj_consume_token(PLUS);
          break;
        case MINUS:
          tok = jj_consume_token(MINUS);
          break;
        default:
          jj_la1[118] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jjtn000.addName(tok.image);
        jjtn000.addSpecial("operator." + count, tok.specialToken);
        count++;
        MultiplicativeExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void MultiplicativeExpression() throws ParseException {
 /*@bgen(jjtree) MultiplicativeExpression */
    ASTMultiplicativeExpression jjtn000 = new ASTMultiplicativeExpression(this, JJTMULTIPLICATIVEEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      UnaryExpression();
      label_53:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STAR:
        case SLASH:
        case REM:
          ;
          break;
        default:
          jj_la1[119] = jj_gen;
          break label_53;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STAR:
          tok = jj_consume_token(STAR);
          break;
        case SLASH:
          tok = jj_consume_token(SLASH);
          break;
        case REM:
          tok = jj_consume_token(REM);
          break;
        default:
          jj_la1[120] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jjtn000.addName(tok.image);
        jjtn000.addSpecial("operator." + count, tok.specialToken);
        count++;
        UnaryExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void UnaryExpression() throws ParseException {
 /*@bgen(jjtree) UnaryExpression */
    ASTUnaryExpression jjtn000 = new ASTUnaryExpression(this, JJTUNARYEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          tok = jj_consume_token(PLUS);
          break;
        case MINUS:
          tok = jj_consume_token(MINUS);
          break;
        default:
          jj_la1[121] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        UnaryExpression();
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("operator", tok.specialToken);
        break;
      case INCR:
        PreIncrementExpression();
        break;
      case DECR:
        PreDecrementExpression();
        break;
      default:
        jj_la1[122] = jj_gen;
        if (jj_2_36(1)) {
          UnaryExpressionNotPlusMinus();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PreIncrementExpression() throws ParseException {
 /*@bgen(jjtree) PreIncrementExpression */
    ASTPreIncrementExpression jjtn000 = new ASTPreIncrementExpression(this, JJTPREINCREMENTEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(INCR);
      PrimaryExpression();
                                 jjtree.closeNodeScope(jjtn000, true);
                                 jjtc000 = false;
                                jjtn000.addSpecial("operator", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PreDecrementExpression() throws ParseException {
 /*@bgen(jjtree) PreDecrementExpression */
    ASTPreDecrementExpression jjtn000 = new ASTPreDecrementExpression(this, JJTPREDECREMENTEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(DECR);
      PrimaryExpression();
                                 jjtree.closeNodeScope(jjtn000, true);
                                 jjtc000 = false;
                                jjtn000.addSpecial("operator", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void UnaryExpressionNotPlusMinus() throws ParseException {
 /*@bgen(jjtree) UnaryExpressionNotPlusMinus */
    ASTUnaryExpressionNotPlusMinus jjtn000 = new ASTUnaryExpressionNotPlusMinus(this, JJTUNARYEXPRESSIONNOTPLUSMINUS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      if (castLookahead()) {
        CastExpression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BANG:
        case TILDE:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case TILDE:
            tok = jj_consume_token(TILDE);
            break;
          case BANG:
            tok = jj_consume_token(BANG);
            break;
          default:
            jj_la1[123] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          UnaryExpression();
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("operator", tok.specialToken);
          break;
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
          PostfixExpression();
          break;
        default:
          jj_la1[124] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PostfixExpression() throws ParseException {
 /*@bgen(jjtree) PostfixExpression */
    ASTPostfixExpression jjtn000 = new ASTPostfixExpression(this, JJTPOSTFIXEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    try {
      PrimaryExpression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCR:
      case DECR:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INCR:
          tok = jj_consume_token(INCR);
          break;
        case DECR:
          tok = jj_consume_token(DECR);
          break;
        default:
          jj_la1[125] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[126] = jj_gen;
        ;
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    if (tok != null) {
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("operator", tok.specialToken);
    }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void CastExpression() throws ParseException {
 /*@bgen(jjtree) CastExpression */
    ASTCastExpression jjtn000 = new ASTCastExpression(this, JJTCASTEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("begin", tok.specialToken);
      Type();
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("end", tok.specialToken);
      UnaryExpression();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PrimaryExpression() throws ParseException {
 /*@bgen(jjtree) PrimaryExpression */
  ASTPrimaryExpression jjtn000 = new ASTPrimaryExpression(this, JJTPRIMARYEXPRESSION);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      PrimaryPrefix();
      label_54:
      while (true) {
        if (jj_2_37(2147483647)) {
          ;
        } else {
          break label_54;
        }
        PrimarySuffix();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PrimaryPrefix() throws ParseException {
 /*@bgen(jjtree) PrimaryPrefix */
  ASTPrimaryPrefix jjtn000 = new ASTPrimaryPrefix(this, JJTPRIMARYPREFIX);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);Token tok;
  Token superTok;
  String name = "";
  int count = 0;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FALSE:
      case NULL:
      case TRUE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        Literal();
        break;
      case THIS:
        tok = jj_consume_token(THIS);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setUsesThisModifier();
    jjtn000.setName("this");
    jjtn000.addSpecial("this", tok.specialToken);
        break;
      default:
        jj_la1[128] = jj_gen;
        if (jj_2_38(2147483647)) {
          label_55:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case IDENTIFIER:
              ;
              break;
            default:
              jj_la1[127] = jj_gen;
              break label_55;
            }
            tok = jj_consume_token(IDENTIFIER);
            jj_consume_token(DOT);
        name = name + tok.image + ".";
            jjtn000.addSpecial("this." + count, tok.specialToken);
            count++;
          }
          superTok = jj_consume_token(SUPER);
          jj_consume_token(DOT);
          tok = jj_consume_token(IDENTIFIER);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setUsesSuperModifier();
    jjtn000.setCount(count);
    name = name + "super." + tok.image;
    jjtn000.setName(name);
    jjtn000.addSpecial("this", superTok.specialToken);
    jjtn000.addSpecial("id", tok.specialToken);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("begin", tok.specialToken);
            Expression();
            tok = jj_consume_token(RPAREN);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
            break;
          case NEW:
            AllocationExpression();
            break;
          default:
            jj_la1[129] = jj_gen;
            if (jj_2_39(2147483647)) {
              ResultType();
              jj_consume_token(DOT);
              jj_consume_token(CLASS);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case IDENTIFIER:
                Name();
                break;
              default:
                jj_la1[130] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void PrimarySuffix() throws ParseException {
 /*@bgen(jjtree) PrimarySuffix */
    ASTPrimarySuffix jjtn000 = new ASTPrimarySuffix(this, JJTPRIMARYSUFFIX);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token tok1;
    Token tok2;
    Token tok3;
    Token generic;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        tok = jj_consume_token(DOT);
           jjtn000.addSpecial("dot", tok.specialToken);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case THIS:
          tok = jj_consume_token(THIS);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
       jjtn000.setName("this");
       jjtn000.addSpecial("id", tok.specialToken);
          break;
        case SUPER:
          tok = jj_consume_token(SUPER);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setName("super");
      jjtn000.addSpecial("id", tok.specialToken);
          break;
        case NEW:
          AllocationExpression();
          break;
        case IDENTIFIER:
        case LT:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LT:
            ReferenceTypeList();
            break;
          default:
            jj_la1[131] = jj_gen;
            ;
          }
          tok = jj_consume_token(IDENTIFIER);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
          break;
        default:
          jj_la1[132] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      case LBRACKET:
        tok = jj_consume_token(LBRACKET);
           jjtn000.addSpecial("[", tok.specialToken);
        Expression();
        tok = jj_consume_token(RBRACKET);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("]", tok.specialToken);
        break;
      case LPAREN:
        Arguments();
                jjtree.closeNodeScope(jjtn000, true);
                jjtc000 = false;
               ((ASTPrimarySuffix)jjtn000).setIsArguments();
        break;
      case LT:
        ReferenceTypeList();
        break;
      default:
        jj_la1[133] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Literal() throws ParseException {
 /*@bgen(jjtree) Literal */
    ASTLiteral jjtn000 = new ASTLiteral(this, JJTLITERAL);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        tok = jj_consume_token(INTEGER_LITERAL);
        break;
      case FLOATING_POINT_LITERAL:
        tok = jj_consume_token(FLOATING_POINT_LITERAL);
        break;
      case CHARACTER_LITERAL:
        tok = jj_consume_token(CHARACTER_LITERAL);
        break;
      case STRING_LITERAL:
        tok = jj_consume_token(STRING_LITERAL);
        break;
      case FALSE:
      case TRUE:
        BooleanLiteral();
        break;
      case NULL:
        NullLiteral();
        break;
      default:
        jj_la1[134] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    if (tok != null) {
      jjtn000.setName(tok.image);
      jjtn000.addSpecial("id", tok.specialToken);
    }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void BooleanLiteral() throws ParseException {
 /*@bgen(jjtree) BooleanLiteral */
    ASTBooleanLiteral jjtn000 = new ASTBooleanLiteral(this, JJTBOOLEANLITERAL);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
        tok = jj_consume_token(TRUE);
        break;
      case FALSE:
        tok = jj_consume_token(FALSE);
        break;
      default:
        jj_la1[135] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("id", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void NullLiteral() throws ParseException {
 /*@bgen(jjtree) NullLiteral */
    ASTNullLiteral jjtn000 = new ASTNullLiteral(this, JJTNULLLITERAL);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(NULL);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.addSpecial("id", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Arguments() throws ParseException {
 /*@bgen(jjtree) Arguments */
    ASTArguments jjtn000 = new ASTArguments(this, JJTARGUMENTS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("begin", tok.specialToken);
      if (jj_2_40(1)) {
        ArgumentList();
      } else {
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        tok = jj_consume_token(COMMA);
                                 jjtn000.addSpecial("comma", tok.specialToken);
        break;
      default:
        jj_la1[136] = jj_gen;
        ;
      }
      tok = jj_consume_token(RPAREN);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ArgumentList() throws ParseException {
 /*@bgen(jjtree) ArgumentList */
    ASTArgumentList jjtn000 = new ASTArgumentList(this, JJTARGUMENTLIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      Expression();
      label_56:
      while (true) {
        if (expressionLookahead()) {
          ;
        } else {
          break label_56;
        }
        tok = jj_consume_token(COMMA);
              jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
        Expression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AllocationExpression() throws ParseException {
 /*@bgen(jjtree) AllocationExpression */
    ASTAllocationExpression jjtn000 = new ASTAllocationExpression(this, JJTALLOCATIONEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(NEW);
             jjtn000.addSpecial("id", tok.specialToken);
      if (jj_2_41(2147483647)) {
        ClassOrInterfaceType();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          ArrayDimsAndInits();
          break;
        case LPAREN:
          Arguments();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            ClassBody();
            break;
          default:
            jj_la1[137] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[138] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FLOAT:
        case INT:
        case LONG:
        case SHORT:
          PrimitiveType();
          ArrayDimsAndInits();
          break;
        default:
          jj_la1[139] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

/*
 * The third LOOKAHEAD specification below is to parse to PrimarySuffix
 * if there is an expression between the "[...]".
 */
  final public void ArrayDimsAndInits() throws ParseException {
 /*@bgen(jjtree) ArrayDimsAndInits */
    ASTArrayDimsAndInits jjtn000 = new ASTArrayDimsAndInits(this, JJTARRAYDIMSANDINITS);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int arrayCount = 0;
    try {
      if (jj_2_44(2)) {
        label_57:
        while (true) {
          tok = jj_consume_token(LBRACKET);
               jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
          Expression();
          tok = jj_consume_token(RBRACKET);
               jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
       arrayCount++;
          if (jj_2_42(2)) {
            ;
          } else {
            break label_57;
          }
        }
        label_58:
        while (true) {
          if (jj_2_43(4)) {
            ;
          } else {
            break label_58;
          }
          tok = jj_consume_token(LBRACKET);
               jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
          tok = jj_consume_token(RBRACKET);
               jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
       arrayCount++;
        }
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          label_59:
          while (true) {
            tok = jj_consume_token(LBRACKET);
               jjtn000.addSpecial("[." + arrayCount, tok.specialToken);
            tok = jj_consume_token(RBRACKET);
               jjtn000.addSpecial("]." + arrayCount, tok.specialToken);
       arrayCount++;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACKET:
              ;
              break;
            default:
              jj_la1[140] = jj_gen;
              break label_59;
            }
          }
          ArrayInitializer();
          break;
        default:
          jj_la1[141] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setArrayCount(arrayCount);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

/*
 * Statement syntax follows.
 */
  final public void Statement() throws ParseException {
 /*@bgen(jjtree) Statement */
    ASTStatement jjtn000 = new ASTStatement(this, JJTSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSERT:
        AssertionStatement();
        break;
      default:
        jj_la1[142] = jj_gen;
        if (jj_2_45(2)) {
          LabeledStatement();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            Block();
            break;
          case SEMICOLON:
            EmptyStatement();
            break;
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case DOUBLE:
          case FALSE:
          case FLOAT:
          case INT:
          case LONG:
          case NEW:
          case NULL:
          case SHORT:
          case SUPER:
          case THIS:
          case TRUE:
          case VOID:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case IDENTIFIER:
          case LPAREN:
          case INCR:
          case DECR:
            StatementExpression();
            tok = jj_consume_token(SEMICOLON);
                                  jjtree.closeNodeScope(jjtn000, true);
                                  jjtc000 = false;
                                 jjtn000.addSpecial("semicolon", tok.specialToken);
            break;
          case SWITCH:
            SwitchStatement();
            break;
          case IF:
            IfStatement();
            break;
          case WHILE:
            WhileStatement();
            break;
          case DO:
            DoStatement();
            break;
          case FOR:
            ForStatement();
            break;
          case BREAK:
            BreakStatement();
            break;
          case CONTINUE:
            ContinueStatement();
            break;
          case RETURN:
            ReturnStatement();
            break;
          case THROW:
            ThrowStatement();
            break;
          case SYNCHRONIZED:
            SynchronizedStatement();
            break;
          case TRY:
            TryStatement();
            break;
          default:
            jj_la1[143] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void LabeledStatement() throws ParseException {
 /*@bgen(jjtree) LabeledStatement */
    ASTLabeledStatement jjtn000 = new ASTLabeledStatement(this, JJTLABELEDSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token colon;
    try {
      tok = jj_consume_token(IDENTIFIER);
      colon = jj_consume_token(COLON);
      Statement();
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.setName(tok.image);
    jjtn000.addSpecial("id", tok.specialToken);
    jjtn000.addSpecial("colon", colon.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void Block() throws ParseException {
 /*@bgen(jjtree) Block */
    ASTBlock jjtn000 = new ASTBlock(this, JJTBLOCK);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("begin", tok.specialToken);
      label_60:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CLASS:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case INTERFACE:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case SEMICOLON:
        case INCR:
        case DECR:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[144] = jj_gen;
          break label_60;
        }
        BlockStatement();
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("end", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void BlockStatement() throws ParseException {
 /*@bgen(jjtree) BlockStatement */
    ASTBlockStatement jjtn000 = new ASTBlockStatement(this, JJTBLOCKSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int count = 0;
    try {
      if (jj_2_46(2147483647)) {
        LocalVariableDeclaration();
        tok = jj_consume_token(SEMICOLON);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
   jjtn000.addSpecial("semicolon", tok.specialToken);
      } else if (jj_2_47(2147483647)) {
        LocalVariableDeclaration();
        tok = jj_consume_token(SEMICOLON);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
   jjtn000.addSpecial("semicolon", tok.specialToken);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSERT:
        case BOOLEAN:
        case BREAK:
        case BYTE:
        case CHAR:
        case CONTINUE:
        case DO:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case FOR:
        case IF:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case RETURN:
        case SHORT:
        case SUPER:
        case SWITCH:
        case SYNCHRONIZED:
        case THIS:
        case THROW:
        case TRUE:
        case TRY:
        case VOID:
        case WHILE:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case LBRACE:
        case SEMICOLON:
        case INCR:
        case DECR:
          Statement();
          break;
        default:
          jj_la1[149] = jj_gen;
          if (jj_2_48(2147483647)) {
            label_61:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case FINAL:
              case ATTRIBUTE:
                ;
                break;
              default:
                jj_la1[145] = jj_gen;
                break label_61;
              }
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case ATTRIBUTE:
                tok = jj_consume_token(ATTRIBUTE);
                Annotation();
                            jjtn000.addSpecial("@."+count, tok.specialToken); count++;
                break;
              case FINAL:
                tok = jj_consume_token(FINAL);
                   jjtn000.addSpecial("final", tok.specialToken);  jjtn000.setFinal(true);
                break;
              default:
                jj_la1[146] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
            UnmodifiedClassDeclaration();
          } else if (jj_2_49(2147483647)) {
            label_62:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case FINAL:
              case ATTRIBUTE:
                ;
                break;
              default:
                jj_la1[147] = jj_gen;
                break label_62;
              }
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case ATTRIBUTE:
                tok = jj_consume_token(ATTRIBUTE);
                Annotation();
                            jjtn000.addSpecial("@."+count, tok.specialToken); count++;
                break;
              case FINAL:
                tok = jj_consume_token(FINAL);
                   jjtn000.addSpecial("final", tok.specialToken); jjtn000.setFinal(true);
                break;
              default:
                jj_la1[148] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
            UnmodifiedInterfaceDeclaration();
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void LocalVariableDeclaration() throws ParseException {
 /*@bgen(jjtree) LocalVariableDeclaration */
    ASTLocalVariableDeclaration jjtn000 = new ASTLocalVariableDeclaration(this, JJTLOCALVARIABLEDECLARATION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok = null;
    int commaCount = 0;
    int count = 0;
    try {
      label_63:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FINAL:
        case ATTRIBUTE:
          ;
          break;
        default:
          jj_la1[150] = jj_gen;
          break label_63;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTRIBUTE:
          tok = jj_consume_token(ATTRIBUTE);
          Annotation();
                            jjtn000.addSpecial("@."+count, tok.specialToken); count++;
          break;
        case FINAL:
          tok = jj_consume_token(FINAL);
                   jjtn000.setUsingFinal(true); jjtn000.addSpecial("final", tok.specialToken);
          break;
        default:
          jj_la1[151] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      Type();
      VariableDeclarator();
      label_64:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[152] = jj_gen;
          break label_64;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken); commaCount++;
        VariableDeclarator();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void EmptyStatement() throws ParseException {
 /*@bgen(jjtree) EmptyStatement */
    ASTEmptyStatement jjtn000 = new ASTEmptyStatement(this, JJTEMPTYSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(SEMICOLON);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
   jjtn000.addSpecial("semicolon", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void StatementExpression() throws ParseException {
 /*@bgen(jjtree) StatementExpression */
    ASTStatementExpression jjtn000 = new ASTStatementExpression(this, JJTSTATEMENTEXPRESSION);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCR:
        PreIncrementExpression();
        break;
      case DECR:
        PreDecrementExpression();
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case DOUBLE:
      case FALSE:
      case FLOAT:
      case INT:
      case LONG:
      case NEW:
      case NULL:
      case SHORT:
      case SUPER:
      case THIS:
      case TRUE:
      case VOID:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
        PrimaryExpression();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
        case INCR:
        case DECR:
        case PLUSASSIGN:
        case MINUSASSIGN:
        case STARASSIGN:
        case SLASHASSIGN:
        case ANDASSIGN:
        case ORASSIGN:
        case XORASSIGN:
        case REMASSIGN:
        case LSHIFTASSIGN:
        case RSIGNEDSHIFTASSIGN:
        case RUNSIGNEDSHIFTASSIGN:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case INCR:
            tok = jj_consume_token(INCR);
              jjtn000.setName("++"); jjtn000.addSpecial("id", tok.specialToken);
            break;
          case DECR:
            tok = jj_consume_token(DECR);
              jjtn000.setName("--"); jjtn000.addSpecial("id", tok.specialToken);
            break;
          case ASSIGN:
          case PLUSASSIGN:
          case MINUSASSIGN:
          case STARASSIGN:
          case SLASHASSIGN:
          case ANDASSIGN:
          case ORASSIGN:
          case XORASSIGN:
          case REMASSIGN:
          case LSHIFTASSIGN:
          case RSIGNEDSHIFTASSIGN:
          case RUNSIGNEDSHIFTASSIGN:
            AssignmentOperator();
            Expression();
            break;
          default:
            jj_la1[153] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[154] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[155] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void SwitchStatement() throws ParseException {
 /*@bgen(jjtree) SwitchStatement */
    ASTSwitchStatement jjtn000 = new ASTSwitchStatement(this, JJTSWITCHSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(SWITCH);
                jjtn000.addSpecial("switch", tok.specialToken);
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("beginExpr", tok.specialToken);
      Expression();
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("endExpr", tok.specialToken);
      tok = jj_consume_token(LBRACE);
           jjtn000.addSpecial("beginBlock", tok.specialToken);
      label_65:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CASE:
        case _DEFAULT:
          ;
          break;
        default:
          jj_la1[156] = jj_gen;
          break label_65;
        }
        SwitchLabel();
        label_66:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSERT:
          case BOOLEAN:
          case BREAK:
          case BYTE:
          case CHAR:
          case CLASS:
          case CONTINUE:
          case DO:
          case DOUBLE:
          case FALSE:
          case FINAL:
          case FLOAT:
          case FOR:
          case IF:
          case INT:
          case INTERFACE:
          case LONG:
          case NEW:
          case NULL:
          case RETURN:
          case SHORT:
          case SUPER:
          case SWITCH:
          case SYNCHRONIZED:
          case THIS:
          case THROW:
          case TRUE:
          case TRY:
          case VOID:
          case WHILE:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case IDENTIFIER:
          case LPAREN:
          case LBRACE:
          case SEMICOLON:
          case INCR:
          case DECR:
          case ATTRIBUTE:
            ;
            break;
          default:
            jj_la1[157] = jj_gen;
            break label_66;
          }
          BlockStatement();
        }
      }
      tok = jj_consume_token(RBRACE);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("endBlock", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void SwitchLabel() throws ParseException {
 /*@bgen(jjtree) SwitchLabel */
    ASTSwitchLabel jjtn000 = new ASTSwitchLabel(this, JJTSWITCHLABEL);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    Token colon;
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
        tok = jj_consume_token(CASE);
        Expression();
        colon = jj_consume_token(COLON);
        break;
      case _DEFAULT:
        tok = jj_consume_token(_DEFAULT);
        colon = jj_consume_token(COLON);
        break;
      default:
        jj_la1[158] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
    jjtn000.addSpecial("id", tok.specialToken);
    jjtn000.addSpecial("colon", colon.specialToken);
    } catch (Throwable jjte000) {
  if (jjtc000) {
    jjtree.clearNodeScope(jjtn000);
    jjtc000 = false;
  } else {
    jjtree.popNode();
  }
  if (jjte000 instanceof RuntimeException) {
    {if (true) throw (RuntimeException)jjte000;}
  }
  if (jjte000 instanceof ParseException) {
    {if (true) throw (ParseException)jjte000;}
  }
  {if (true) throw (Error)jjte000;}
    } finally {
  if (jjtc000) {
    jjtree.closeNodeScope(jjtn000, true);
  }
    }
  }

  final public void IfStatement() throws ParseException {
 /*@bgen(jjtree) IfStatement */
    ASTIfStatement jjtn000 = new ASTIfStatement(this, JJTIFSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(IF);
            jjtn000.addSpecial("if", tok.specialToken);
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("beginExpr", tok.specialToken);
      Expression();
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("endExpr", tok.specialToken);
      Statement();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELSE:
        tok = jj_consume_token(ELSE);
                jjtn000.setHasElse(); jjtn000.addSpecial("else", tok.specialToken);
        Statement();
        break;
      default:
        jj_la1[159] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void WhileStatement() throws ParseException {
 /*@bgen(jjtree) WhileStatement */
    ASTWhileStatement jjtn000 = new ASTWhileStatement(this, JJTWHILESTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(WHILE);
               jjtn000.addSpecial("while", tok.specialToken);
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("beginExpr", tok.specialToken);
      Expression();
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("endExpr", tok.specialToken);
      Statement();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ForStatement() throws ParseException {
 /*@bgen(jjtree) ForStatement */
    ASTForStatement jjtn000 = new ASTForStatement(this, JJTFORSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(FOR);
             jjtn000.addSpecial("for", tok.specialToken);
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("beginExpr", tok.specialToken);
      if (forLookahead()) {
        LocalVariableDeclaration();
        tok = jj_consume_token(COLON);
               jjtn000.addSpecial("loopover", tok.specialToken);
        Expression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FINAL:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case SEMICOLON:
        case INCR:
        case DECR:
        case ATTRIBUTE:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case DOUBLE:
          case FALSE:
          case FINAL:
          case FLOAT:
          case INT:
          case LONG:
          case NEW:
          case NULL:
          case SHORT:
          case SUPER:
          case THIS:
          case TRUE:
          case VOID:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case IDENTIFIER:
          case LPAREN:
          case INCR:
          case DECR:
          case ATTRIBUTE:
            ForInit();
            break;
          default:
            jj_la1[160] = jj_gen;
            ;
          }
          tok = jj_consume_token(SEMICOLON);
               jjtn000.addSpecial("init", tok.specialToken);
          if (jj_2_50(1)) {
            Expression();
          } else {
            ;
          }
          tok = jj_consume_token(SEMICOLON);
               jjtn000.addSpecial("test", tok.specialToken);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case DOUBLE:
          case FALSE:
          case FLOAT:
          case INT:
          case LONG:
          case NEW:
          case NULL:
          case SHORT:
          case SUPER:
          case THIS:
          case TRUE:
          case VOID:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case CHARACTER_LITERAL:
          case STRING_LITERAL:
          case IDENTIFIER:
          case LPAREN:
          case INCR:
          case DECR:
            ForUpdate();
            break;
          default:
            jj_la1[161] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[162] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("endExpr", tok.specialToken);
      Statement();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ForInit() throws ParseException {
 /*@bgen(jjtree) ForInit */
  ASTForInit jjtn000 = new ASTForInit(this, JJTFORINIT);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      if (jj_2_51(2147483647)) {
        LocalVariableDeclaration();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case DOUBLE:
        case FALSE:
        case FLOAT:
        case INT:
        case LONG:
        case NEW:
        case NULL:
        case SHORT:
        case SUPER:
        case THIS:
        case TRUE:
        case VOID:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case CHARACTER_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case LPAREN:
        case INCR:
        case DECR:
          StatementExpressionList();
          break;
        default:
          jj_la1[163] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void DoStatement() throws ParseException {
 /*@bgen(jjtree) DoStatement */
    ASTDoStatement jjtn000 = new ASTDoStatement(this, JJTDOSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(DO);
            jjtn000.addSpecial("do", tok.specialToken);
      Statement();
      tok = jj_consume_token(WHILE);
               jjtn000.addSpecial("while", tok.specialToken);
      tok = jj_consume_token(LPAREN);
           jjtn000.addSpecial("beginExpr", tok.specialToken);
      Expression();
      tok = jj_consume_token(RPAREN);
           jjtn000.addSpecial("endExpr", tok.specialToken);
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void StatementExpressionList() throws ParseException {
 /*@bgen(jjtree) StatementExpressionList */
    ASTStatementExpressionList jjtn000 = new ASTStatementExpressionList(this, JJTSTATEMENTEXPRESSIONLIST);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int commaCount = 0;
    try {
      StatementExpression();
      label_67:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[164] = jj_gen;
          break label_67;
        }
        tok = jj_consume_token(COMMA);
             jjtn000.addSpecial("comma." + commaCount, tok.specialToken);  commaCount++;
        StatementExpression();
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ForUpdate() throws ParseException {
 /*@bgen(jjtree) ForUpdate */
  ASTForUpdate jjtn000 = new ASTForUpdate(this, JJTFORUPDATE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
    try {
      StatementExpressionList();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void BreakStatement() throws ParseException {
 /*@bgen(jjtree) BreakStatement */
    ASTBreakStatement jjtn000 = new ASTBreakStatement(this, JJTBREAKSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(BREAK);
               jjtn000.addSpecial("break", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        tok = jj_consume_token(IDENTIFIER);
                      jjtn000.setName(tok.image); jjtn000.addSpecial("id", tok.specialToken);
        break;
      default:
        jj_la1[165] = jj_gen;
        ;
      }
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ContinueStatement() throws ParseException {
 /*@bgen(jjtree) ContinueStatement */
    ASTContinueStatement jjtn000 = new ASTContinueStatement(this, JJTCONTINUESTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(CONTINUE);
                  jjtn000.addSpecial("continue", tok.specialToken);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        tok = jj_consume_token(IDENTIFIER);
                      jjtn000.setName(tok.image); jjtn000.addSpecial("id", tok.specialToken);
        break;
      default:
        jj_la1[166] = jj_gen;
        ;
      }
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ReturnStatement() throws ParseException {
 /*@bgen(jjtree) ReturnStatement */
    ASTReturnStatement jjtn000 = new ASTReturnStatement(this, JJTRETURNSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(RETURN);
                jjtn000.addSpecial("return", tok.specialToken);
      if (jj_2_52(1)) {
        Expression();
      } else {
        ;
      }
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void ThrowStatement() throws ParseException {
 /*@bgen(jjtree) ThrowStatement */
    ASTThrowStatement jjtn000 = new ASTThrowStatement(this, JJTTHROWSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(THROW);
               jjtn000.addSpecial("throw", tok.specialToken);
      Expression();
      tok = jj_consume_token(SEMICOLON);
            jjtree.closeNodeScope(jjtn000, true);
            jjtc000 = false;
           jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void SynchronizedStatement() throws ParseException {
 /*@bgen(jjtree) SynchronizedStatement */
    ASTSynchronizedStatement jjtn000 = new ASTSynchronizedStatement(this, JJTSYNCHRONIZEDSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(SYNCHRONIZED);
                       jjtn000.addSpecial("synchronized", tok.specialToken);
      tok = jj_consume_token(LPAREN);
            jjtn000.addSpecial("beginExpr", tok.specialToken);
      Expression();
      tok = jj_consume_token(RPAREN);
            jjtn000.addSpecial("endExpr", tok.specialToken);
      Block();
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void TryStatement() throws ParseException {
 /*@bgen(jjtree) TryStatement */
    ASTTryStatement jjtn000 = new ASTTryStatement(this, JJTTRYSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    int catchCount = 0;
    try {
      tok = jj_consume_token(TRY);
              jjtn000.addSpecial("try", tok.specialToken);
      Block();
      label_68:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CATCH:
          ;
          break;
        default:
          jj_la1[167] = jj_gen;
          break label_68;
        }
        tok = jj_consume_token(CATCH);
                  jjtn000.setHasCatch(); jjtn000.addSpecial("catch" + catchCount, tok.specialToken);
        tok = jj_consume_token(LPAREN);
              jjtn000.addSpecial("beginExpr" + catchCount, tok.specialToken);
        FormalParameter();
        tok = jj_consume_token(RPAREN);
              jjtn000.addSpecial("endExpr" + catchCount, tok.specialToken);
        Block();
     catchCount++;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FINALLY:
        tok = jj_consume_token(FINALLY);
                    jjtn000.setHasFinally(); jjtn000.addSpecial("finally", tok.specialToken);
        Block();
        break;
      default:
        jj_la1[168] = jj_gen;
        ;
      }
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final public void AssertionStatement() throws ParseException {
 /*@bgen(jjtree) AssertionStatement */
    ASTAssertionStatement jjtn000 = new ASTAssertionStatement(this, JJTASSERTIONSTATEMENT);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token tok;
    try {
      tok = jj_consume_token(ASSERT);
    if (!jdk1_4) {
      System.err.println("WARNING: assert declared in pre-jdk 1.4 target");
    }
    jjtn000.addSpecial("assert", tok.specialToken);
      Expression();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        tok = jj_consume_token(COLON);
                    jjtn000.addSpecial("colon", tok.specialToken);
        Expression();
        break;
      default:
        jj_la1[169] = jj_gen;
        ;
      }
      tok = jj_consume_token(SEMICOLON);
    jjtree.closeNodeScope(jjtn000, true);
    jjtc000 = false;
   jjtn000.addSpecial("semicolon", tok.specialToken);
    } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
    } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000, true);
    }
    }
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_37(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(36, xla); }
  }

  final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_38(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(37, xla); }
  }

  final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_39(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(38, xla); }
  }

  final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_40(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(39, xla); }
  }

  final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_41(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(40, xla); }
  }

  final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_42(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(41, xla); }
  }

  final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_43(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(42, xla); }
  }

  final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_44(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(43, xla); }
  }

  final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_45(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(44, xla); }
  }

  final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_46(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(45, xla); }
  }

  final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_47(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(46, xla); }
  }

  final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_48(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(47, xla); }
  }

  final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_49(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(48, xla); }
  }

  final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_50(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(49, xla); }
  }

  final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_51(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(50, xla); }
  }

  final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_52(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(51, xla); }
  }

  final private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_32()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) return true;
    }
    return false;
  }

  final private boolean jj_3R_307() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_342() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_3R_351()) return true;
    return false;
  }

  final private boolean jj_3R_302() {
    Token xsp;
    if (jj_3R_307()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_307()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_186()) return true;
    return false;
  }

  final private boolean jj_3R_341() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_111()) return true;
    return false;
  }

  final private boolean jj_3_43() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_340() {
    if (jj_3R_136()) return true;
    return false;
  }

  final private boolean jj_3R_119() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3_42() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3_44() {
    Token xsp;
    if (jj_3_42()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_42()) { jj_scanpos = xsp; break; }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_43()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_208() {
    if (jj_scan_token(CLASS)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_340()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_341()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_342()) jj_scanpos = xsp;
    if (jj_3R_306()) return true;
    return false;
  }

  final private boolean jj_3R_174() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) jj_scanpos = xsp;
    if (jj_3R_206()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(88)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_295() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_44()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) return true;
    }
    return false;
  }

  final private boolean jj_3R_301() {
    if (jj_3R_306()) return true;
    return false;
  }

  final private boolean jj_3R_151() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3_30() {
    if (jj_3R_97()) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_98()) jj_scanpos = xsp;
    if (jj_scan_token(THIS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3_41() {
    if (jj_3R_111()) return true;
    return false;
  }

  final private boolean jj_3R_377() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3R_278() {
    if (jj_3R_185()) return true;
    if (jj_3R_295()) return true;
    return false;
  }

  final private boolean jj_3R_376() {
    if (jj_3R_85()) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_294() {
    if (jj_3R_283()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_301()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_375() {
    if (jj_3R_97()) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_293() {
    if (jj_3R_295()) return true;
    return false;
  }

  final private boolean jj_3R_363() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_375()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_376()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_377()) jj_scanpos = xsp;
    if (jj_scan_token(SUPER)) return true;
    if (jj_3R_283()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_374() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_3() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_71()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(ENUM)) return true;
    return false;
  }

  final private boolean jj_3R_362() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_374()) jj_scanpos = xsp;
    if (jj_scan_token(THIS)) return true;
    if (jj_3R_283()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_70() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_120()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_150() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_277() {
    if (jj_3R_111()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_293()) {
    jj_scanpos = xsp;
    if (jj_3R_294()) return true;
    }
    return false;
  }

  final private boolean jj_3R_149() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3_2() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_70()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_96() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_150()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_151()) jj_scanpos = xsp;
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_348() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_362()) {
    jj_scanpos = xsp;
    if (jj_3R_363()) return true;
    }
    return false;
  }

  final private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) jj_scanpos = xsp;
    if (jj_scan_token(THIS)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3_29() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_95()) {
    jj_scanpos = xsp;
    if (jj_3R_96()) return true;
    }
    return false;
  }

  final private boolean jj_3R_69() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_119()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_1() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_69()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_scan_token(NEW)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) return true;
    }
    return false;
  }

  final private boolean jj_3R_297() {
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  final private boolean jj_3R_324() {
    if (jj_3R_349()) return true;
    return false;
  }

  final private boolean jj_3R_308() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_323() {
    if (jj_3R_348()) return true;
    return false;
  }

  final private boolean jj_3R_110() {
    if (jj_3R_93()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_308()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_322() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_347()) return true;
    return false;
  }

  final private boolean jj_3R_320() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3_40() {
    if (jj_3R_110()) return true;
    return false;
  }

  final private boolean jj_3R_283() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_40()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_297()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_212() {
    if (jj_3R_136()) return true;
    return false;
  }

  final private boolean jj_3R_246() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_245() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_211() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_243()) {
    jj_scanpos = xsp;
    if (jj_3R_244()) {
    jj_scanpos = xsp;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_177() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_211()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_212()) jj_scanpos = xsp;
    if (jj_scan_token(IDENTIFIER)) return true;
    xsp = jj_scanpos;
    if (jj_3R_320()) jj_scanpos = xsp;
    if (jj_3R_321()) return true;
    xsp = jj_scanpos;
    if (jj_3R_322()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_323()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_324()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(88)) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_290() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  final private boolean jj_3R_373() {
    if (jj_scan_token(VARARG)) return true;
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_3R_162()) return true;
    return false;
  }

  final private boolean jj_3R_384() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_383() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_372() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_383()) {
    jj_scanpos = xsp;
    if (jj_3R_384()) return true;
    }
    return false;
  }

  final private boolean jj_3R_359() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_372()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_84()) return true;
    xsp = jj_scanpos;
    if (jj_3R_373()) jj_scanpos = xsp;
    if (jj_3R_354()) return true;
    return false;
  }

  final private boolean jj_3R_289() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(66)) {
    jj_scanpos = xsp;
    if (jj_scan_token(35)) return true;
    }
    return false;
  }

  final private boolean jj_3R_360() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_359()) return true;
    return false;
  }

  final private boolean jj_3R_275() {
    if (jj_3R_290()) return true;
    return false;
  }

  final private boolean jj_3R_346() {
    if (jj_3R_359()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_360()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_274() {
    if (jj_3R_289()) return true;
    return false;
  }

  final private boolean jj_3R_321() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_346()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_219() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(71)) {
    jj_scanpos = xsp;
    if (jj_scan_token(75)) {
    jj_scanpos = xsp;
    if (jj_scan_token(77)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_3R_274()) {
    jj_scanpos = xsp;
    if (jj_3R_275()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_350() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_225() {
    if (jj_3R_162()) return true;
    return false;
  }

  final private boolean jj_3R_224() {
    if (jj_3R_283()) return true;
    return false;
  }

  final private boolean jj_3R_161() {
    if (jj_3R_162()) return true;
    return false;
  }

  final private boolean jj_3R_223() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_325() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_3R_321()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_350()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_scan_token(DOT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_161()) jj_scanpos = xsp;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_296() {
    if (jj_3R_162()) return true;
    return false;
  }

  final private boolean jj_3R_282() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_296()) jj_scanpos = xsp;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_281() {
    if (jj_3R_221()) return true;
    return false;
  }

  final private boolean jj_3R_328() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_327() {
    if (jj_3R_206()) return true;
    return false;
  }

  final private boolean jj_3R_280() {
    if (jj_scan_token(SUPER)) return true;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3R_326() {
    if (jj_scan_token(THROWS)) return true;
    if (jj_3R_347()) return true;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_3R_136()) return true;
    return false;
  }

  final private boolean jj_3R_279() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  final private boolean jj_3R_256() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_255() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  final private boolean jj_3R_194() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_222()) {
    jj_scanpos = xsp;
    if (jj_3R_223()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) {
    jj_scanpos = xsp;
    if (jj_3R_225()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_222() {
    if (jj_scan_token(DOT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_279()) {
    jj_scanpos = xsp;
    if (jj_3R_280()) {
    jj_scanpos = xsp;
    if (jj_3R_281()) {
    jj_scanpos = xsp;
    if (jj_3R_282()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_253() {
    if (jj_scan_token(NATIVE)) return true;
    return false;
  }

  final private boolean jj_3R_252() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_251() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  final private boolean jj_3R_250() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  final private boolean jj_3_39() {
    if (jj_3R_109()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_248() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3R_213() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_247()) {
    jj_scanpos = xsp;
    if (jj_3R_248()) {
    jj_scanpos = xsp;
    if (jj_3R_249()) {
    jj_scanpos = xsp;
    if (jj_3R_250()) {
    jj_scanpos = xsp;
    if (jj_3R_251()) {
    jj_scanpos = xsp;
    if (jj_3R_252()) {
    jj_scanpos = xsp;
    if (jj_3R_253()) {
    jj_scanpos = xsp;
    if (jj_3R_254()) {
    jj_scanpos = xsp;
    if (jj_3R_255()) {
    jj_scanpos = xsp;
    if (jj_3R_256()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_247() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_178() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_213()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_214()) jj_scanpos = xsp;
    if (jj_3R_109()) return true;
    if (jj_3R_325()) return true;
    xsp = jj_scanpos;
    if (jj_3R_326()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_327()) {
    jj_scanpos = xsp;
    if (jj_3R_328()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(88)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_3R_80()) return true;
    return false;
  }

  final private boolean jj_3R_192() {
    if (jj_3R_109()) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_191() {
    if (jj_3R_221()) return true;
    return false;
  }

  final private boolean jj_3R_104() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(NEW)) return true;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_190() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_311() {
    if (jj_scan_token(COMMA)) return true;
    return false;
  }

  final private boolean jj_3R_146() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3_27() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_94()) return true;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3_38() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_108()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3_28() {
    if (jj_3R_94()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_27()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_103() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(SUPER)) return true;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_186() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_28()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_311()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_189() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_220()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3_26() {
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_3R_186()) return true;
    return false;
  }

  final private boolean jj_3R_94() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_148()) {
    jj_scanpos = xsp;
    if (jj_3_26()) return true;
    }
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  final private boolean jj_3R_152() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_187()) {
    jj_scanpos = xsp;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) {
    jj_scanpos = xsp;
    if (jj_3R_192()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  final private boolean jj_3_37() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_3R_103()) {
    jj_scanpos = xsp;
    if (jj_3R_104()) {
    jj_scanpos = xsp;
    if (jj_scan_token(82)) {
    jj_scanpos = xsp;
    if (jj_scan_token(86)) {
    jj_scanpos = xsp;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_3R_219()) return true;
    return false;
  }

  final private boolean jj_3R_370() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_153() {
    if (jj_3R_194()) return true;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_3R_152()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_153()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_354() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_370()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_446() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(105)) {
    jj_scanpos = xsp;
    if (jj_scan_token(106)) return true;
    }
    return false;
  }

  final private boolean jj_3R_355() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_94()) return true;
    return false;
  }

  final private boolean jj_3R_197() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_84()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_333() {
    if (jj_3R_354()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_355()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_334() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_333()) return true;
    return false;
  }

  final private boolean jj_3R_198() {
    if (jj_3R_97()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_446()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_271() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_270() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_269() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3R_268() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_267() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_266() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_3R_198()) return true;
    return false;
  }

  final private boolean jj_3R_265() {
    if (jj_scan_token(VOLATILE)) return true;
    return false;
  }

  final private boolean jj_3R_264() {
    if (jj_scan_token(TRANSIENT)) return true;
    return false;
  }

  final private boolean jj_3R_216() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_263()) {
    jj_scanpos = xsp;
    if (jj_3R_264()) {
    jj_scanpos = xsp;
    if (jj_3R_265()) {
    jj_scanpos = xsp;
    if (jj_3R_266()) {
    jj_scanpos = xsp;
    if (jj_3R_267()) {
    jj_scanpos = xsp;
    if (jj_3R_268()) {
    jj_scanpos = xsp;
    if (jj_3R_269()) {
    jj_scanpos = xsp;
    if (jj_3R_270()) {
    jj_scanpos = xsp;
    if (jj_3R_271()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_263() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  final private boolean jj_3R_180() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_216()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_84()) return true;
    if (jj_3R_333()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_334()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(88)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_92() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_147()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_25() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_92()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  final private boolean jj_3R_91() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_146()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_159() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(96)) {
    jj_scanpos = xsp;
    if (jj_scan_token(95)) return true;
    }
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3_24() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_91()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_3R_197()) return true;
    return false;
  }

  final private boolean jj_3R_101() {
    Token xsp;
    xsp = jj_scanpos;
    lookingAhead = true;
    jj_semLA = castLookahead();
    lookingAhead = false;
    if (!jj_semLA || jj_3R_158()) {
    jj_scanpos = xsp;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_3R_180()) return true;
    return false;
  }

  final private boolean jj_3R_144() {
    if (jj_3R_178()) return true;
    return false;
  }

  final private boolean jj_3R_143() {
    if (jj_3R_176()) return true;
    return false;
  }

  final private boolean jj_3R_357() {
    if (jj_scan_token(DECR)) return true;
    if (jj_3R_97()) return true;
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_3R_175()) return true;
    return false;
  }

  final private boolean jj_3R_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_142()) {
    jj_scanpos = xsp;
    if (jj_3R_143()) {
    jj_scanpos = xsp;
    lookingAhead = true;
    jj_semLA = methodDeclarationLookahead();
    lookingAhead = false;
    if (!jj_semLA || jj_3R_144()) {
    jj_scanpos = xsp;
    if (jj_3R_145()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_3R_90()) return true;
    return false;
  }

  final private boolean jj_3R_356() {
    if (jj_scan_token(INCR)) return true;
    if (jj_3R_97()) return true;
    return false;
  }

  final private boolean jj_3R_345() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_23()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_36() {
    if (jj_3R_101()) return true;
    return false;
  }

  final private boolean jj_3R_337() {
    if (jj_3R_357()) return true;
    return false;
  }

  final private boolean jj_3R_344() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_3R_351()) return true;
    return false;
  }

  final private boolean jj_3R_336() {
    if (jj_3R_356()) return true;
    return false;
  }

  final private boolean jj_3R_343() {
    if (jj_3R_136()) return true;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_343()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_344()) jj_scanpos = xsp;
    if (jj_3R_345()) return true;
    return false;
  }

  final private boolean jj_3R_335() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(107)) {
    jj_scanpos = xsp;
    if (jj_scan_token(108)) return true;
    }
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_318() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) {
    jj_scanpos = xsp;
    if (jj_3_36()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_241() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3R_239() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_237() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  final private boolean jj_3R_209() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_235()) {
    jj_scanpos = xsp;
    if (jj_3R_236()) {
    jj_scanpos = xsp;
    if (jj_3R_237()) {
    jj_scanpos = xsp;
    if (jj_3R_238()) {
    jj_scanpos = xsp;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) {
    jj_scanpos = xsp;
    if (jj_3R_241()) {
    jj_scanpos = xsp;
    if (jj_3R_242()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_235() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  final private boolean jj_3R_382() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(109)) {
    jj_scanpos = xsp;
    if (jj_scan_token(110)) {
    jj_scanpos = xsp;
    if (jj_scan_token(114)) return true;
    }
    }
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_176() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_209()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_210()) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(88)) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_316() {
    if (jj_3R_318()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_382()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_140() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_371() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(107)) {
    jj_scanpos = xsp;
    if (jj_scan_token(108)) return true;
    }
    if (jj_3R_316()) return true;
    return false;
  }

  final private boolean jj_3R_314() {
    if (jj_3R_316()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_371()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_422() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_358() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(115)) {
    jj_scanpos = xsp;
    if (jj_scan_token(116)) {
    jj_scanpos = xsp;
    if (jj_scan_token(117)) return true;
    }
    }
    if (jj_3R_314()) return true;
    return false;
  }

  final private boolean jj_3R_312() {
    if (jj_3R_314()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_358()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_408() {
    if (jj_scan_token(ASSERT)) return true;
    if (jj_3R_93()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_422()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_89() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_141()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_433() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_3R_206()) return true;
    return false;
  }

  final private boolean jj_3_22() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_89()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(ENUM)) return true;
    return false;
  }

  final private boolean jj_3R_88() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_140()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_21() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_88()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_87() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_87()) jj_scanpos = xsp;
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  final private boolean jj_3R_338() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(94)) {
    jj_scanpos = xsp;
    if (jj_scan_token(93)) {
    jj_scanpos = xsp;
    if (jj_scan_token(100)) {
    jj_scanpos = xsp;
    if (jj_scan_token(101)) return true;
    }
    }
    }
    if (jj_3R_312()) return true;
    return false;
  }

  final private boolean jj_3R_86() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_432() {
    if (jj_scan_token(CATCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_359()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_206()) return true;
    return false;
  }

  final private boolean jj_3_19() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_86()) jj_scanpos = xsp;
    if (jj_3R_84()) return true;
    return false;
  }

  final private boolean jj_3R_83() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) return true;
    }
    return false;
  }

  final private boolean jj_3R_309() {
    if (jj_3R_312()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_338()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_18() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_83()) jj_scanpos = xsp;
    if (jj_3R_84()) return true;
    if (jj_3R_85()) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_421() {
    if (jj_scan_token(TRY)) return true;
    if (jj_3R_206()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_432()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_433()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_319() {
    if (jj_scan_token(INSTANCEOF)) return true;
    if (jj_3R_99()) return true;
    return false;
  }

  final private boolean jj_3R_304() {
    if (jj_3R_309()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_319()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_420() {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_206()) return true;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3R_317() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(99)) {
    jj_scanpos = xsp;
    if (jj_scan_token(102)) return true;
    }
    if (jj_3R_304()) return true;
    return false;
  }

  final private boolean jj_3R_419() {
    if (jj_scan_token(THROW)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_298() {
    if (jj_3R_304()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_317()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3_52() {
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_418() {
    if (jj_scan_token(RETURN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_52()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_315() {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_3R_298()) return true;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_3R_80()) return true;
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3R_284() {
    if (jj_3R_298()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_315()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_431() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_417() {
    if (jj_scan_token(CONTINUE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_431()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_353() {
    if (jj_3R_306()) return true;
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_3R_136()) return true;
    return false;
  }

  final private boolean jj_3R_352() {
    if (jj_3R_283()) return true;
    return false;
  }

  final private boolean jj_3R_313() {
    if (jj_scan_token(XOR)) return true;
    if (jj_3R_284()) return true;
    return false;
  }

  final private boolean jj_3R_430() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_226() {
    if (jj_3R_284()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_313()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_330() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_352()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_353()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_416() {
    if (jj_scan_token(BREAK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_430()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_117() {
    if (jj_3R_84()) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_310() {
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_226()) return true;
    return false;
  }

  final private boolean jj_3R_445() {
    if (jj_3R_449()) return true;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_3R_226()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_310()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_450() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_410()) return true;
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_3R_75()) return true;
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_449() {
    if (jj_3R_410()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_450()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_305() {
    if (jj_scan_token(SC_AND)) return true;
    if (jj_3R_205()) return true;
    return false;
  }

  final private boolean jj_3R_332() {
    if (jj_scan_token(SEMICOLON)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_17()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_3R_205()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_305()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_331() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_330()) return true;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_300() {
    if (jj_scan_token(SC_OR)) return true;
    if (jj_3R_173()) return true;
    return false;
  }

  final private boolean jj_3R_329() {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_3R_351()) return true;
    return false;
  }

  final private boolean jj_3R_414() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_379()) return true;
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_3R_173()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_300()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_262() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_116() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_170()) return true;
    }
    return false;
  }

  final private boolean jj_3R_261() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_260() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3_51() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_116()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) return true;
    }
    return false;
  }

  final private boolean jj_3R_259() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_258() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_215() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_257()) {
    jj_scanpos = xsp;
    if (jj_3R_258()) {
    jj_scanpos = xsp;
    if (jj_3R_259()) {
    jj_scanpos = xsp;
    if (jj_3R_260()) {
    jj_scanpos = xsp;
    if (jj_3R_261()) {
    jj_scanpos = xsp;
    if (jj_3R_262()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_257() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  final private boolean jj_3R_448() {
    if (jj_3R_449()) return true;
    return false;
  }

  final private boolean jj_3R_179() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_215()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(ENUM)) return true;
    if (jj_3R_85()) return true;
    xsp = jj_scanpos;
    if (jj_3R_329()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_330()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_331()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_332()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_scan_token(88)) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_291() {
    if (jj_scan_token(HOOK)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_74()) return true;
    return false;
  }

  final private boolean jj_3R_82() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_138()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_16() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_82()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(ENUM)) return true;
    return false;
  }

  final private boolean jj_3R_74() {
    if (jj_3R_125()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_291()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_447() {
    if (jj_3R_378()) return true;
    return false;
  }

  final private boolean jj_3R_444() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_447()) {
    jj_scanpos = xsp;
    if (jj_3R_448()) return true;
    }
    return false;
  }

  final private boolean jj_3R_78() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_3R_135()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_15() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_78()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_79()) jj_scanpos = xsp;
    if (jj_3R_80()) return true;
    xsp = jj_scanpos;
    if (jj_3R_81()) jj_scanpos = xsp;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_77() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_438() {
    if (jj_3R_445()) return true;
    return false;
  }

  final private boolean jj_3R_132() {
    if (jj_3R_180()) return true;
    return false;
  }

  final private boolean jj_3_14() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_77()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  final private boolean jj_3R_76() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_3R_133()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_50() {
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_3R_179()) return true;
    return false;
  }

  final private boolean jj_3R_437() {
    if (jj_3R_444()) return true;
    return false;
  }

  final private boolean jj_3_13() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_76()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_3R_178()) return true;
    return false;
  }

  final private boolean jj_3_12() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_429() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_437()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3_50()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_438()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_3R_177()) return true;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_3R_176()) return true;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_3R_175()) return true;
    return false;
  }

  final private boolean jj_3R_428() {
    if (jj_3R_378()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_3R_174()) return true;
    return false;
  }

  final private boolean jj_3R_292() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(92)) {
    jj_scanpos = xsp;
    if (jj_scan_token(120)) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_scan_token(125)) {
    jj_scanpos = xsp;
    if (jj_scan_token(118)) {
    jj_scanpos = xsp;
    if (jj_scan_token(119)) {
    jj_scanpos = xsp;
    if (jj_scan_token(126)) {
    jj_scanpos = xsp;
    if (jj_scan_token(127)) {
    jj_scanpos = xsp;
    if (jj_scan_token(128)) {
    jj_scanpos = xsp;
    if (jj_scan_token(122)) {
    jj_scanpos = xsp;
    if (jj_scan_token(124)) {
    jj_scanpos = xsp;
    if (jj_scan_token(123)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_75() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3R_129()) {
    jj_scanpos = xsp;
    lookingAhead = true;
    jj_semLA = methodDeclarationLookahead();
    lookingAhead = false;
    if (!jj_semLA || jj_3R_130()) {
    jj_scanpos = xsp;
    if (jj_3R_131()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_415() {
    if (jj_scan_token(FOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    lookingAhead = true;
    jj_semLA = forLookahead();
    lookingAhead = false;
    if (!jj_semLA || jj_3R_428()) {
    jj_scanpos = xsp;
    if (jj_3R_429()) return true;
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_379()) return true;
    return false;
  }

  final private boolean jj_3R_276() {
    if (jj_3R_292()) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_3R_75()) return true;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_3R_74()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_276()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_413() {
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_379()) return true;
    return false;
  }

  final private boolean jj_3R_234() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_233() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  final private boolean jj_3R_232() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  final private boolean jj_3R_230() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_scan_token(ABSTRACT)) return true;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_scan_token(STRICTFP)) return true;
    return false;
  }

  final private boolean jj_3R_207() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_227()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) {
    jj_scanpos = xsp;
    if (jj_3R_229()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) {
    jj_scanpos = xsp;
    if (jj_3R_233()) {
    jj_scanpos = xsp;
    if (jj_3R_234()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_227() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  final private boolean jj_3R_427() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_379()) return true;
    return false;
  }

  final private boolean jj_3R_175() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_207()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_208()) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(88)) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_369() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_111()) return true;
    return false;
  }

  final private boolean jj_3R_412() {
    if (jj_scan_token(IF)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_379()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_427()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_3R_75()) return true;
    return false;
  }

  final private boolean jj_3R_351() {
    if (jj_3R_111()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_369()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_306() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_10()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_436() {
    if (jj_3R_349()) return true;
    return false;
  }

  final private boolean jj_3R_361() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_80()) return true;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_3R_99()) return true;
    return false;
  }

  final private boolean jj_3R_288() {
    if (jj_scan_token(SUPER)) return true;
    return false;
  }

  final private boolean jj_3R_287() {
    if (jj_scan_token(EXTENDS)) return true;
    return false;
  }

  final private boolean jj_3R_443() {
    if (jj_scan_token(_DEFAULT)) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_347() {
    if (jj_3R_80()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_361()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_273() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) return true;
    }
    if (jj_3R_99()) return true;
    return false;
  }

  final private boolean jj_3R_442() {
    if (jj_scan_token(CASE)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_435() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_442()) {
    jj_scanpos = xsp;
    if (jj_3R_443()) return true;
    }
    return false;
  }

  final private boolean jj_3_35() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_426() {
    if (jj_3R_435()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_436()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_scan_token(HOOK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_273()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3R_100() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    }
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_85()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_203()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_411() {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_93()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_426()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_3R_137()) return true;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_3R_85()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_165()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_166()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_441() {
    if (jj_3R_292()) return true;
    if (jj_3R_93()) return true;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_440() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  final private boolean jj_3R_439() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  final private boolean jj_3R_434() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_439()) {
    jj_scanpos = xsp;
    if (jj_3R_440()) {
    jj_scanpos = xsp;
    if (jj_3R_441()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_425() {
    if (jj_3R_97()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_434()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_424() {
    if (jj_3R_357()) return true;
    return false;
  }

  final private boolean jj_3R_423() {
    if (jj_3R_356()) return true;
    return false;
  }

  final private boolean jj_3R_410() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_423()) {
    jj_scanpos = xsp;
    if (jj_3R_424()) {
    jj_scanpos = xsp;
    if (jj_3R_425()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_200() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3_34() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_100()) return true;
    return false;
  }

  final private boolean jj_3R_409() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_100()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_199()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_200()) {
    jj_scanpos = xsp;
    if (jj_3R_201()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_34()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_299() {
    if (jj_3R_111()) return true;
    return false;
  }

  final private boolean jj_3R_386() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_333()) return true;
    return false;
  }

  final private boolean jj_3R_286() {
    if (jj_scan_token(BIT_AND)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_299()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_285() {
    if (jj_3R_111()) return true;
    return false;
  }

  final private boolean jj_3R_407() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_272() {
    if (jj_scan_token(EXTENDS)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_285()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_286()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_406() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_385() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_406()) {
    jj_scanpos = xsp;
    if (jj_3R_407()) return true;
    }
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_3R_84()) return true;
    return false;
  }

  final private boolean jj_3R_109() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_163()) {
    jj_scanpos = xsp;
    if (jj_3R_164()) return true;
    }
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_scan_token(VOID)) return true;
    return false;
  }

  final private boolean jj_3R_169() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_378() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_385()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_84()) return true;
    if (jj_3R_333()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_386()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_3R_85()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_272()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_49() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) jj_scanpos = xsp;
    if (jj_scan_token(INTERFACE)) return true;
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_115() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_169()) return true;
    }
    return false;
  }

  final private boolean jj_3R_405() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_404() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_381() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_404()) {
    jj_scanpos = xsp;
    if (jj_3R_405()) return true;
    }
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_217()) return true;
    return false;
  }

  final private boolean jj_3_48() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_115()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  final private boolean jj_3R_167() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_368() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_381()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_210()) return true;
    return false;
  }

  final private boolean jj_3R_114() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_168()) return true;
    }
    return false;
  }

  final private boolean jj_3R_403() {
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_3R_217()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_218()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_402() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_380() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_402()) {
    jj_scanpos = xsp;
    if (jj_3R_403()) return true;
    }
    return false;
  }

  final private boolean jj_3_47() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_114()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_80()) return true;
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3R_113() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_3R_167()) return true;
    }
    return false;
  }

  final private boolean jj_3R_367() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_380()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_208()) return true;
    return false;
  }

  final private boolean jj_3_46() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_113()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_84()) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_366() {
    if (jj_3R_379()) return true;
    return false;
  }

  final private boolean jj_3R_365() {
    if (jj_3R_378()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_185() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_scan_token(56)) {
    jj_scanpos = xsp;
    if (jj_scan_token(45)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(38)) {
    jj_scanpos = xsp;
    if (jj_scan_token(31)) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_364() {
    if (jj_3R_378()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_349() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_364()) {
    jj_scanpos = xsp;
    if (jj_3R_365()) {
    jj_scanpos = xsp;
    if (jj_3R_366()) {
    jj_scanpos = xsp;
    if (jj_3R_367()) {
    jj_scanpos = xsp;
    if (jj_3R_368()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_136() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_181()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_339() {
    if (jj_3R_349()) return true;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_339()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_183() {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_73()) return true;
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_3R_73()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_8()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_scan_token(89)) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_100()) return true;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_379()) return true;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_74()) return true;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_73()) return true;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_3R_172()) return true;
    return false;
  }

  final private boolean jj_3R_401() {
    if (jj_3R_421()) return true;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_73() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3_7()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_100()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_33()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_400() {
    if (jj_3R_420()) return true;
    return false;
  }

  final private boolean jj_3R_399() {
    if (jj_3R_419()) return true;
    return false;
  }

  final private boolean jj_3R_398() {
    if (jj_3R_418()) return true;
    return false;
  }

  final private boolean jj_3R_397() {
    if (jj_3R_417()) return true;
    return false;
  }

  final private boolean jj_3R_396() {
    if (jj_3R_416()) return true;
    return false;
  }

  final private boolean jj_3R_122() {
    if (jj_3R_85()) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_73()) return true;
    return false;
  }

  final private boolean jj_3R_395() {
    if (jj_3R_415()) return true;
    return false;
  }

  final private boolean jj_3R_394() {
    if (jj_3R_414()) return true;
    return false;
  }

  final private boolean jj_3R_196() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_393() {
    if (jj_3R_413()) return true;
    return false;
  }

  final private boolean jj_3R_392() {
    if (jj_3R_412()) return true;
    return false;
  }

  final private boolean jj_3R_391() {
    if (jj_3R_411()) return true;
    return false;
  }

  final private boolean jj_3R_303() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_122()) return true;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_3R_185()) return true;
    Token xsp;
    if (jj_3R_196()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_196()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_390() {
    if (jj_3R_410()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_3R_122()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_303()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_389() {
    if (jj_3R_409()) return true;
    return false;
  }

  final private boolean jj_3R_388() {
    if (jj_3R_206()) return true;
    return false;
  }

  final private boolean jj_3_45() {
    if (jj_3R_112()) return true;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_3R_111()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_195()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_387() {
    if (jj_3R_408()) return true;
    return false;
  }

  final private boolean jj_3R_379() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_387()) {
    jj_scanpos = xsp;
    if (jj_3_45()) {
    jj_scanpos = xsp;
    if (jj_3R_388()) {
    jj_scanpos = xsp;
    if (jj_3R_389()) {
    jj_scanpos = xsp;
    if (jj_3R_390()) {
    jj_scanpos = xsp;
    if (jj_3R_391()) {
    jj_scanpos = xsp;
    if (jj_3R_392()) {
    jj_scanpos = xsp;
    if (jj_3R_393()) {
    jj_scanpos = xsp;
    if (jj_3R_394()) {
    jj_scanpos = xsp;
    if (jj_3R_395()) {
    jj_scanpos = xsp;
    if (jj_3R_396()) {
    jj_scanpos = xsp;
    if (jj_3R_397()) {
    jj_scanpos = xsp;
    if (jj_3R_398()) {
    jj_scanpos = xsp;
    if (jj_3R_399()) {
    jj_scanpos = xsp;
    if (jj_3R_400()) {
    jj_scanpos = xsp;
    if (jj_3R_401()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3_5()) return true;
    }
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_72()) return true;
    return false;
  }

  final private boolean jj_3R_99() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) return true;
    }
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_171() {
    if (jj_3R_85()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_204()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_3R_185()) return true;
    return false;
  }

  final private boolean jj_3R_121() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_scan_token(ATTRIBUTE)) return true;
    if (jj_3R_171()) return true;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_3R_99()) return true;
    return false;
  }

  public JavaParserTokenManager token_source;
  CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[170];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static private int[] jj_la1_4;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
      jj_la1_3();
      jj_la1_4();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x4040000,0x0,0x0,0x0,0x40000,0x40000,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x82500000,0x40000,0x40000,0x0,0x82500000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x40000,0x86540000,0x40000,0x40000,0x40000,0x20000000,0x0,0x0,0x40000,0x40000,0x0,0x40000,0x40000,0x0,0x0,0x0,0x82500000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x82500000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xd6780000,0x0,0x0,0x0,0x0,0x82500000,0x0,0x0,0x82500000,0x0,0x0,0x82500000,0x0,0x82500000,0x82500000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x82500000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x82500000,0x0,0x0,0x80000,0xd2700000,0xd6780000,0x0,0x0,0x0,0x0,0xd2780000,0x0,0x0,0x0,0x0,0x0,0x82500000,0x20800000,0xd6780000,0x20800000,0x0,0x82500000,0x82500000,0x82500000,0x82500000,0x0,0x0,0x0,0x1000000,0x0,0x0,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x80000,0x800,0x6704012,0x2000000,0x0,0x0,0x4404000,0x4400010,0x4400010,0x0,0x0,0x4,0x400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x0,0x0,0x8000004,0x8000004,0x100a040,0x6700010,0x6700010,0x0,0x770a050,0x2700010,0x2700010,0x400,0x0,0x0,0x0,0x0,0x0,0x4400000,0x4000,0x4400000,0x770e052,0x4404000,0x400000,0x400000,0x0,0x2400010,0x0,0x4400000,0x4400000,0x0,0x6700010,0x6700010,0x0,0x0,0x4,0x770a050,0x6700010,0x6700010,0x0,0x0,0x0,0x0,0x0,0x0,0x26710010,0x26710010,0x0,0x0,0x0,0x0,0x0,0x0,0x100a050,0x10,0x10,0x0,0x700000,0x700000,0x0,0x0,0x0,0xf986e2d8,0x0,0x0,0x0,0x0,0x4906a048,0x2000000,0x0,0x100a040,0x0,0x0,0x100a040,0x0,0x100a040,0x100a040,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4906a048,0x0,0x0,0x0,0x40040008,0x20000,0x0,0x0,0x48020000,0x0,0x40008,0x8,0x0,0x0,0x0,0x100a040,0x0,0x0,0x0,0xf986a2c8,0xf986e2d8,0x10,0x10,0x10,0x10,0xf986a2c8,0x10,0x10,0x0,0x0,0x0,0x4906a048,0x0,0xf986e2d8,0x0,0x1,0x4906a058,0x4906a048,0x4906a058,0x4906a048,0x0,0x0,0x0,0x0,0x20,0x0,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x8000,0x0,0x4000000,0x1000000,0x0,0x0,0x0,0x1000000,0x40000000,0x0,0x0,0x40000,0x2000000,0x100000,0x2000000,0x2000000,0x8000,0x0,0x8000,0x0,0x2000000,0x20000000,0x0,0x0,0x8000,0x0,0x0,0x1000000,0x8022,0x0,0x0,0x0,0x2000000,0x1000000,0x1000000,0x40000,0x100000,0x0,0x8000,0x0,0x8000,0x0,0x0,0x0,0x0,0x0,0x2000000,0x0,0x0,0x1000000,0x0,0x0,0x1000000,0x40000000,0x0,0x8022,0x22,0x22,0x2000000,0x1000000,0x10000000,0x400000,0x100000,0x2000000,0x0,0x0,0x40000000,0x1,0x1100000,0x1000000,0x400000,0x2000000,0x8000,0x0,0x0,0x8000000,0x0,0x0,0x40000000,0x40000000,0x1,0x114e8dc,0x1000000,0x40000000,0x8000,0x40000000,0x4004e894,0x0,0x1000000,0x0,0x400000,0x400000,0x8000,0x20000000,0x0,0x8010,0x40000000,0x40000000,0x2000000,0x2000000,0x10000000,0x10000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x60000000,0x60000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000000,0x8004e894,0x0,0x0,0x8000,0x6884,0x40000,0x8000,0x40000000,0x40008000,0x44440000,0x6884,0x4,0x2000000,0x100000,0x440000,0x0,0x400000,0x400000,0x0,0x114e8dc,0x114e8dc,0x0,0x0,0x0,0x0,0x114e8dc,0x0,0x0,0x2000000,0x10000000,0x10000000,0x4e894,0x0,0x114e8dc,0x0,0x0,0x4e894,0x4e894,0x104e894,0x4e894,0x2000000,0x8000,0x8000,0x0,0x0,0x0,};
   }
   private static void jj_la1_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8000,0x0,0x0,0x0,0x300000,0x0,0x0,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x600,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x300000,0x0,0x0,0x0,0x0,0x0,0x0,0xffc00000,0xffc00000,0x2,0x80,0x100,0x10000,0x20000,0x8000,0x48,0x48,0x0,0x30,0x30,0x380000,0x380000,0x1800,0x1800,0x46000,0x46000,0x1800,0x1e00,0x1,0x1,0x600,0x600,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x600,0x600,0x0,0x0,0x0,0x0,0x600,0x0,0x0,0x0,0xffc00600,0xffc00600,0x600,0x0,0x600,0x0,0x0,0x600,0x600,0x600,0x600,0x0,0x0,0x0,0x0,0x0,0x4,};
   }
   private static void jj_la1_4() {
      jj_la1_4 = new int[] {0x0,0x0,0x2,0x0,0x0,0x0,0x2,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x2,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x2,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x2,0x2,0x0,0x0,0x0,0x2,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x2,0x0,0x2,0x2,0x0,0x0,0x0,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x2,0x2,0x2,0x0,0x2,0x2,0x0,0x1,0x1,0x0,0x0,0x2,0x0,0x0,0x2,0x0,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[52];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public JavaParser(java.io.InputStream stream) {
    jj_input_stream = CharStream.make(stream, 1, 1);
    token_source = new JavaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public JavaParser(java.io.Reader stream) {
    jj_input_stream = CharStream.make(stream, 1, 1);
    token_source = new JavaParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public JavaParser(JavaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(JavaParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 170; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[130];
    for (int i = 0; i < 130; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 170; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 130; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 52; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
